#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::event_func_896()
{
    // event 748_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(16)) > (15))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_movement()->get_speed()) == (0))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_748_4_end;
        FrameObject * single_instance_748_4_0; single_instance_748_4_0 = pick_random(enemylonestarnew_278_instances);
        if (single_instance_748_4_0 == NULL) goto event_748_4_end;
        ((Active*)((Active*)single_instance_748_4_0))->alterables->values.set(15, 1); // 'enemy-lonestarnew'
        ((Active*)((Active*)single_instance_748_4_0))->alterables->values.set(16, 0); // 'enemy-lonestarnew'
    }
    event_748_4_end: ;
}
void Frames::event_func_897()
{
    // event 749_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(18)) == (0))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_749_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(15, 0); // 'enemy-lonestarnew'
            ((Active*)*it)->alterables->values.set(16, 0); // 'enemy-lonestarnew'
        }
    }
    event_749_4_end: ;
}
void Frames::event_func_898()
{
    // event 750_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        if (!check_overlap(enemylonestarnew_278_instances, enemylonestarnew_278_instances)) goto event_750_4_end;
        FrameObject * single_instance_750_4_0; single_instance_750_4_0 = pick_random(enemylonestarnew_278_instances);
        if (single_instance_750_4_0 == NULL) goto event_750_4_end;
        ((Active*)((Active*)single_instance_750_4_0))->alterables->values.set(18, 1); // 'enemy-lonestarnew'
    }
    event_750_4_end: ;
}
void Frames::event_func_899()
{
    // event 751_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) == (2))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(7)) == (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(15)) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(17)) > (66))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_751_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
        }
    }
    event_751_4_end: ;
}
void Frames::event_func_900()
{
    // event 752_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) == (2))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(7)) == (1))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(14)) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(17)) > (66))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_752_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(17);
        }
    }
    event_752_4_end: ;
}
void Frames::event_func_901()
{
    // event 753_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(7)) == (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(15)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(16)) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_753_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_753_4_end: ;
}
void Frames::event_func_902()
{
    // event 754_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(7)) == (1))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(14)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(17)) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_754_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(13);
        }
    }
    event_754_4_end: ;
}
void Frames::event_func_903()
{
    // event 755_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_755_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-lonestarnew'
        }
    }
    event_755_4_end: ;
}
void Frames::event_func_904()
{
    // event 756_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_756_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(7, 1); // 'enemy-lonestarnew'
        }
    }
    event_756_4_end: ;
}
void Frames::event_func_905()
{
    // event 757_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_frame()) == (12))) { it.deselect(); continue; }
            if (!(((Active*)(*it))->test_animation(16))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_757_4_end;
        if (not_always_757_4_0 > loop_count) {
            not_always_757_4_0 = loop_count + 2;
            goto event_757_4_end;
        }
        not_always_757_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        FrameObject * single_instance_757_4_1; single_instance_757_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemylonestarnew_278_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_757_4_1 == NULL)
                    single_instance_757_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_757_4_1))->set_direction(get_direction_int(((Active*)single_instance_757_4_1)->x, ((Active*)single_instance_757_4_1)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        ((Active*)((Active*)single_instance_757_4_1))->get_movement()->set_speed(60);
    }
    event_757_4_end: ;
}
void Frames::event_func_906()
{
    // event 758_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_frame()) == (12))) { it.deselect(); continue; }
            if (!(((Active*)(*it))->test_animation(17))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_758_4_end;
        if (not_always_758_4_0 > loop_count) {
            not_always_758_4_0 = loop_count + 2;
            goto event_758_4_end;
        }
        not_always_758_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        FrameObject * single_instance_758_4_1; single_instance_758_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemylonestarnew_278_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_758_4_1 == NULL)
                    single_instance_758_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_758_4_1))->set_direction(get_direction_int(((Active*)single_instance_758_4_1)->x, ((Active*)single_instance_758_4_1)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        ((Active*)((Active*)single_instance_758_4_1))->get_movement()->set_speed(60);
    }
    event_758_4_end: ;
}
void Frames::event_func_907()
{
    // event 761_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_761_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemylonestarnew_278_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemylonestarnew_278_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_761_4_0; single_instance_761_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemylonestarnew_278_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + -10), parent->layer);
                if (single_instance_761_4_0 == NULL)
                    single_instance_761_4_0 = new_obj;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 20); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 20); // 'camera shaker'
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        {
            loop_debris_running = true;
            int times = int(8);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
    }
    event_761_4_end: ;
}
void Frames::event_func_908()
{
    // event 764_4
    {
        // group: General Enemy
        ((Active*)get_instance(screenfar_277_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x());
        ((Active*)get_instance(screenfar_277_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y());
    }
    event_764_4_end: ;
}
void Frames::event_func_909()
{
    // event 769_4
    {
        // group: Disappearing Blocks
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_769_4_end;
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_769_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(8)) == (0))) goto event_769_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_769_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, -10); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(2, 1); // 'Player'
    }
    event_769_4_end: ;
}
void Frames::event_func_910()
{
    // event 770_4
    {
        // group: Disappearing Blocks
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_770_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_770_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_770_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_770_4_end: ;
}
void Frames::event_func_911()
{
    // event 771_4
    {
        // group: Disappearing Blocks
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_771_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_771_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_771_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(15);
        }
    }
    event_771_4_end: ;
}
void Frames::event_func_912()
{
    // event 772_4
    {
        // group: Disappearing Blocks
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_772_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_772_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_772_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_772_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_772_4_end: ;
}
void Frames::event_func_913()
{
    // event 773_4
    {
        // group: Disappearing Blocks
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_773_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_773_4_end;
        if (!(is_player_pressed_once(1, CONTROL_BUTTON2))) goto event_773_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_773_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_773_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
            ((Active*)*it)->alterables->values.set(2, 55); // 'Sprite'
            ((Active*)*it)->start_animation();
        }
    }
    event_773_4_end: ;
}
void Frames::event_func_914()
{
    // event 774_4
    {
        // group: Disappearing Blocks
        detector_94_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(detector_94_instances, dissappear_153_instances)) goto event_774_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_774_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_774_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
        }
    }
    event_774_4_end: ;
}
void Frames::event_func_915()
{
    // event 776_4
    {
        // group: Disappearing Blocks
        dissappear_153_instances.clear_selection();
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) == (1))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_776_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(0, 1); // 'dissappear'
        }
    }
    event_776_4_end: ;
}
void Frames::event_func_916()
{
    // event 777_4
    {
        // group: Disappearing Blocks
        dissappear_153_instances.clear_selection();
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (30))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(0)) <= (111))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_777_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            ((Active*)*it)->blend_color.set_alpha_coefficient(230);
            ((Active*)*it)->alterables->values.set(2, 1); // 'dissappear'
        }
    }
    event_777_4_end: ;
}
void Frames::event_func_917()
{
    // event 778_4
    {
        // group: Disappearing Blocks
        dissappear_153_instances.clear_selection();
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (111))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_778_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(1, 0); // 'dissappear'
            ((Active*)*it)->blend_color.set_alpha_coefficient(0);
            ((Active*)*it)->alterables->values.set(0, 0); // 'dissappear'
            ((Active*)*it)->alterables->values.set(2, 0); // 'dissappear'
        }
    }
    event_778_4_end: ;
}
void Frames::event_func_918()
{
    // event 779_4
    {
        // group: Disappearing Blocks
        player_93_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(player_93_instances, dissappear_153_instances)) goto event_779_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_779_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) >= (((Active*)get_single(dissappear_153_instances, default_active_instance))->get_y()+18))) goto event_779_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()+(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(dissappear_153_instances, default_active_instance))->get_y())-16);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_779_4_end: ;
}
void Frames::event_func_919()
{
    // event 780_4
    {
        // group: Disappearing Blocks
        player_93_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(player_93_instances, dissappear_153_instances)) goto event_780_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_780_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) < (((Active*)get_single(dissappear_153_instances, default_active_instance))->get_y()+18))) goto event_780_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()-(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(dissappear_153_instances, default_active_instance))->get_y())-22);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_780_4_end: ;
}
void Frames::event_func_920()
{
    // event 781_4
    {
        // group: Bullet Redirectors
        sendup_154_instances.clear_selection();
        for (ObjectIterator it(sendup_154_instances); !it.end(); ++it) {
            ((Active*)*it)->set_scale(((Active*)*it)->alterables->values.get(0));
        }
        sendright_156_instances.clear_selection();
        for (ObjectIterator it(sendright_156_instances); !it.end(); ++it) {
            ((Active*)*it)->set_scale(((Active*)*it)->alterables->values.get(0));
        }
        senddown_157_instances.clear_selection();
        for (ObjectIterator it(senddown_157_instances); !it.end(); ++it) {
            ((Active*)*it)->set_scale(((Active*)*it)->alterables->values.get(0));
        }
        sendleft_158_instances.clear_selection();
        for (ObjectIterator it(sendleft_158_instances); !it.end(); ++it) {
            ((Active*)*it)->set_scale(((Active*)*it)->alterables->values.get(0));
        }
    }
    event_781_4_end: ;
}
void Frames::event_func_921()
{
    // event 782_4
    {
        // group: Bullet Redirectors
        sendup_154_instances.clear_selection();
        for (ObjectIterator it(sendup_154_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (1))) { it.deselect(); continue; }
        }
        if (!sendup_154_instances.has_selection()) goto event_782_4_end;
        for (ObjectIterator it(sendup_154_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 0.01); // 'SendUp'
        }
    }
    event_782_4_end: ;
}
void Frames::event_func_922()
{
    // event 783_4
    {
        // group: Bullet Redirectors
        sendright_156_instances.clear_selection();
        for (ObjectIterator it(sendright_156_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (1))) { it.deselect(); continue; }
        }
        if (!sendright_156_instances.has_selection()) goto event_783_4_end;
        for (ObjectIterator it(sendright_156_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 0.01); // 'SendRight'
        }
    }
    event_783_4_end: ;
}
void Frames::event_func_923()
{
    // event 784_4
    {
        // group: Bullet Redirectors
        sendleft_158_instances.clear_selection();
        for (ObjectIterator it(sendleft_158_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (1))) { it.deselect(); continue; }
        }
        if (!sendleft_158_instances.has_selection()) goto event_784_4_end;
        for (ObjectIterator it(sendleft_158_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 0.01); // 'SendLeft'
        }
    }
    event_784_4_end: ;
}
void Frames::event_func_924()
{
    // event 785_4
    {
        // group: Bullet Redirectors
        senddown_157_instances.clear_selection();
        for (ObjectIterator it(senddown_157_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) > (1))) { it.deselect(); continue; }
        }
        if (!senddown_157_instances.has_selection()) goto event_785_4_end;
        for (ObjectIterator it(senddown_157_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 0.01); // 'SendDown'
        }
    }
    event_785_4_end: ;
}
void Frames::event_func_925()
{
    // event 790_4
    {
        // group: Bullet Redirectors
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) != (0))) { it.deselect(); continue; }
        }
        if (!bullet_121_instances.has_selection()) goto event_790_4_end;
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 0); // 'Bullet'
        }
    }
    event_790_4_end: ;
}
void Frames::event_func_926()
{
    // event 794_4
    {
        // group: Eyeblock
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_794_4_end;
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_794_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(8)) == (0))) goto event_794_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_794_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, -10); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(2, 1); // 'Player'
    }
    event_794_4_end: ;
}
void Frames::event_func_927()
{
    // event 795_4
    {
        // group: Eyeblock
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_795_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_795_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_795_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_795_4_end: ;
}
void Frames::event_func_928()
{
    // event 796_4
    {
        // group: Eyeblock
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_796_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_796_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_796_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(15);
        }
    }
    event_796_4_end: ;
}
void Frames::event_func_929()
{
    // event 797_4
    {
        // group: Eyeblock
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_797_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_797_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_797_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_797_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_797_4_end: ;
}
void Frames::event_func_930()
{
    // event 798_4
    {
        // group: Eyeblock
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_798_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_798_4_end;
        if (!(is_player_pressed_once(1, CONTROL_BUTTON2))) goto event_798_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_798_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_798_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
            ((Active*)*it)->alterables->values.set(2, 55); // 'Sprite'
            ((Active*)*it)->start_animation();
        }
    }
    event_798_4_end: ;
}
void Frames::event_func_931()
{
    // event 799_4
    {
        // group: Eyeblock
        detector_94_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objeyeblock_169_instances)) goto event_799_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_799_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_799_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
        }
    }
    event_799_4_end: ;
}
void Frames::event_func_932()
{
    // event 800_4
    {
        // group: Eyeblock
        player_93_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(player_93_instances, objeyeblock_169_instances)) goto event_800_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_800_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) >= (((Active*)get_single(objeyeblock_169_instances, default_active_instance))->get_y()+18))) goto event_800_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()+(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(objeyeblock_169_instances, default_active_instance))->get_y())-16);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 95); // 'Player'
    }
    event_800_4_end: ;
}
void Frames::event_func_933()
{
    // event 801_4
    {
        // group: Eyeblock
        player_93_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(player_93_instances, objeyeblock_169_instances)) goto event_801_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_801_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) < (((Active*)get_single(objeyeblock_169_instances, default_active_instance))->get_y()+18))) goto event_801_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()-(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(objeyeblock_169_instances, default_active_instance))->get_y())-22);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 95); // 'Player'
    }
    event_801_4_end: ;
}
void Frames::event_func_934()
{
    // event 808_4
    {
        // group: Eyeblock
        objeyeblock_169_instances.clear_selection();
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_on(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_808_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_808_4_end: ;
}
void Frames::event_func_935()
{
    // event 809_4
    {
        // group: Eyeblock
        objeyeblock_169_instances.clear_selection();
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_809_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_809_4_end: ;
}
void Frames::event_func_936()
{
    // event 810_4
    {
        // group: Eyeblock
        objeyeblock_169_instances.clear_selection();
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_on(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_810_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 0); // 'obj-eyeblock'
        }
    }
    event_810_4_end: ;
}
void Frames::event_func_937()
{
    // event 811_4
    {
        // group: Eyeblock
        objeyeblock_169_instances.clear_selection();
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_811_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 1); // 'obj-eyeblock'
        }
    }
    event_811_4_end: ;
}
void Frames::event_func_938()
{
    // event 813_4
    {
        // group: Eyeblock
        bullet_121_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(bullet_121_instances, objeyeblock_169_instances)) goto event_813_4_end;
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
    }
    event_813_4_end: ;
}
void Frames::event_func_939()
{
    // event 815_4
    {
        // group: Ded
        if (!((global_values->get(0)) <= (0))) goto event_815_4_end;
        FrameObject * single_instance_815_4_0; single_instance_815_4_0 = NULL;
        // select single: true false false
        sprite_99_instances.clear_selection();
        for (ObjectIterator p_it(sprite_99_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + -16), parent->layer);
                if (single_instance_815_4_0 == NULL)
                    single_instance_815_4_0 = new_obj;
            }
        }
        manager.ignore_controls = true;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 1e+21); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.add(10, 1); // 'Player'
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_815_4_end: ;
}
void Frames::event_func_940()
{
    // event 816_4
    {
        // group: Ded
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(10)) >= (178))) goto event_816_4_end;
        if (not_always_816_4_0 > loop_count) {
            not_always_816_4_0 = loop_count + 2;
            goto event_816_4_end;
        }
        not_always_816_4_0 = loop_count + 2;
        global_values->set(3, 1);
        next_frame = 3 + 0;    
    
    }
    event_816_4_end: ;
}
void Frames::event_func_941()
{
    // event 817_4
    {
        // group: None
        player_93_instances.clear_selection();
        active5_6_instances.clear_selection();
        if (!check_overlap(player_93_instances, active5_6_instances)) goto event_817_4_end;
        next_frame = 5 + 0;    
    
    }
    event_817_4_end: ;
}
void Frames::event_func_942()
{
    // event 818_4
    {
        // group: None
        ((Text*)get_instance(extraguys_143_instances))->set_string(str_x_18+number_to_string(global_values->get(2)));
    }
    event_818_4_end: ;
}
void Frames::event_func_943()
{
    // event 820_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->get_x()+((Active*)*it)->alterables->values.get(0)+((Active*)*it)->alterables->values.get(6));
            ((Active*)*it)->set_y(((Active*)*it)->get_y()+((Active*)*it)->alterables->values.get(1));
            ((Active*)*it)->set_angle(((Active*)*it)->get_angle()+((Active*)*it)->alterables->values.get(3), 0);
        }
    }
    event_820_4_end: ;
}
void Frames::event_func_944()
{
    // event 821_4
    {
        // group: Debris
        every_821_4_0 += manager.dt;
        if (every_821_4_0 < 0.07) goto event_821_4_end;
        every_821_4_0 -= 0.07;
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(1, ((Active*)*it)->alterables->values.get(2)); // 'debris'
        }
    }
    event_821_4_end: ;
}
void Frames::event_func_945()
{
    // event 822_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (0))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_822_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_822_4_end: ;
}
void Frames::event_func_946()
{
    // event 823_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (1))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_823_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(13);
        }
    }
    event_823_4_end: ;
}
void Frames::event_func_947()
{
    // event 824_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (2))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_824_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(14);
        }
    }
    event_824_4_end: ;
}
void Frames::event_func_948()
{
    // event 825_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (3))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_825_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(15);
        }
    }
    event_825_4_end: ;
}
void Frames::event_func_949()
{
    // event 826_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (4))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_826_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
        }
    }
    event_826_4_end: ;
}
void Frames::event_func_950()
{
    // event 827_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (5))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_827_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(17);
        }
    }
    event_827_4_end: ;
}
void Frames::event_func_951()
{
    // event 828_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (6))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_828_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(18);
        }
    }
    event_828_4_end: ;
}
void Frames::event_func_952()
{
    // event 829_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (7))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_829_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(19);
        }
    }
    event_829_4_end: ;
}
void Frames::event_func_953()
{
    // event 830_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (8))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_830_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(20);
        }
    }
    event_830_4_end: ;
}
void Frames::event_func_954()
{
    // event 831_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (9))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_831_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(21);
        }
    }
    event_831_4_end: ;
}
void Frames::event_func_955()
{
    // event 832_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (10))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_832_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(22);
        }
    }
    event_832_4_end: ;
}
void Frames::event_func_956()
{
    // event 833_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (11))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_833_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(23);
        }
    }
    event_833_4_end: ;
}
void Frames::event_func_957()
{
    // event 834_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (12))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_834_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(24);
        }
    }
    event_834_4_end: ;
}
void Frames::event_func_958()
{
    // event 835_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        if (!check_not_overlap(debris_182_instances, screen_148_instances)) goto event_835_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_835_4_end: ;
}
void Frames::event_func_959()
{
    // event 837_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) == (1))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(25)) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_837_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(25);
        }
    }
    event_837_4_end: ;
}
void Frames::event_func_960()
{
    // event 838_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) == (2))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(26)) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_838_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(26);
        }
    }
    event_838_4_end: ;
}
void Frames::event_func_961()
{
    // event 839_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) == (3))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(27)) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_839_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(27);
        }
    }
    event_839_4_end: ;
}
void Frames::event_func_962()
{
    // event 840_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) == (4))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(28)) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_840_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(28);
        }
    }
    event_840_4_end: ;
}
void Frames::event_func_963()
{
    // event 841_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) > (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(1)) >= (1))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_841_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(1, 1); // 'debris'
            ((Active*)*it)->alterables->values.set(0, ((Active*)*it)->alterables->values.get(0)*0.9); // 'debris'
        }
    }
    event_841_4_end: ;
}
void Frames::event_func_964()
{
    // event 842_4
    {
        // group: Debris
        debris_182_instances.clear_selection();
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) > (0))) { it.deselect(); continue; }
        }
        if (!debris_182_instances.has_selection()) goto event_842_4_end;
        for (ObjectIterator it(debris_182_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, sin_deg(global_values->get(6)*115+(115*1.256*((Active*)*it)->alterables->values.get(3)))*3.0); // 'debris'
            ((Active*)*it)->set_y(((Active*)*it)->get_y()+(((Active*)*it)->alterables->values.get(3)+4)/MathHelper()/6.0);
        }
    }
    event_842_4_end: ;
}
void Frames::event_func_965()
{
    // event 847_4
    {
        // group: Bullet Powerup
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(12)) > (0))) goto event_847_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.sub(12, 1); // 'Player'
    }
    event_847_4_end: ;
}
void Frames::event_func_966()
{
    // event 848_4
    {
        // group: Bullet Powerup
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(12)) > (0))) goto event_848_4_end;
        if (not_always_848_4_0 > loop_count) {
            not_always_848_4_0 = loop_count + 2;
            goto event_848_4_end;
        }
        not_always_848_4_0 = loop_count + 2;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(14, 1); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(15, 3); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(16, 999); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(13, 1.5); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(14, 12); // 'Player'
    }
    event_848_4_end: ;
}
void Frames::event_func_967()
{
    // event 849_4
    {
        // group: Bullet Powerup
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(12)) == (0))) goto event_849_4_end;
        if (not_always_849_4_0 > loop_count) {
            not_always_849_4_0 = loop_count + 2;
            goto event_849_4_end;
        }
        not_always_849_4_0 = loop_count + 2;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(14, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(15, 1); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(16, 1); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(13, 1); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(14, 0); // 'Player'
        ((Active*)get_instance(uipowerupindicator_243_instances))->set_visible(false);
    }
    event_849_4_end: ;
}
void Frames::event_func_968()
{
    // event 850_4
    {
        // group: Bullet Powerup
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(12)) > (0))) goto event_850_4_end;
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_850_4_0;
            ((Active*)get_instance(uipowerupindicator_243_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + -34);
            pos_end_850_4_0: ;
        }
        ((Active*)get_instance(uipowerupindicator_243_instances))->force_frame(18-((((Active*)get_instance(player_93_instances))->alterables->values.get(12)/MathHelper()/1200.0)*18));
        ((Active*)get_instance(uipowerupindicator_243_instances))->set_visible(true);
    }
    event_850_4_end: ;
}
void Frames::event_func_969()
{
    // event 851_4
    {
        // group: Sproingy Spring
        player_93_instances.clear_selection();
        springleft_163_instances.clear_selection();
        if (!check_overlap(player_93_instances, springleft_163_instances)) goto event_851_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, -15); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(5, 1); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(19, 15); // 'Player'
    }
    event_851_4_end: ;
}
void Frames::event_func_970()
{
    // event 852_4
    {
        // group: Sproingy Spring
        player_93_instances.clear_selection();
        springright_164_instances.clear_selection();
        if (!check_overlap(player_93_instances, springright_164_instances)) goto event_852_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(0);
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 15); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(5, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(19, 15); // 'Player'
    }
    event_852_4_end: ;
}
void Frames::event_func_971()
{
    // event 854_4
    {
        // group: Wings
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_854_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(17)) == (1))) goto event_854_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(8)) == (0))) goto event_854_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, -10); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(17, 0); // 'Player'
    }
    event_854_4_end: ;
}
void Frames::event_func_972()
{
    // event 855_4
    {
        // group: Wings
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(17)) == (1))) goto event_855_4_end;
        ((Active*)get_instance(spritewings_200_instances))->move_back(((Active*)get_instance(sprite_99_instances)));
        ((Active*)get_instance(spritewings_200_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x());
        ((Active*)get_instance(spritewings_200_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()+4);
        ((Active*)get_instance(spritewings_200_instances))->set_visible(true);
    }
    event_855_4_end: ;
}
void Frames::event_func_973()
{
    // event 856_4
    {
        // group: Wings
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(17)) == (0))) goto event_856_4_end;
        ((Active*)get_instance(spritewings_200_instances))->set_visible(false);
    }
    event_856_4_end: ;
}
void Frames::event_func_974()
{
    // event 857_4
    {
        // group: Wings
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(2)) == (0))) goto event_857_4_end;
        ((Active*)get_instance(spritewings_200_instances))->set_visible(false);
    }
    event_857_4_end: ;
}
void Frames::event_func_975()
{
    // event 858_4
    {
        // group: Laser redirectors
        every_858_4_0 += manager.dt;
        if (every_858_4_0 < 1.0) goto event_858_4_end;
        every_858_4_0 -= 1.0;
        screenfar_277_instances.clear_selection();
        objlasergun_201_instances.clear_selection();
        if (!check_overlap(screenfar_277_instances, objlasergun_201_instances)) goto event_858_4_end;
        for (ObjectIterator it(objlasergun_201_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
        FrameObject * single_instance_858_4_1; single_instance_858_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(objlasergun_201_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_858_4_1 == NULL)
                    single_instance_858_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_858_4_1))->set_direction(((Active*)get_single(objlasergun_201_instances, default_active_instance))->get_direction());
    }
    event_858_4_end: ;
}
void Frames::event_func_976()
{
    // event 869_4
    {
        // group: Laser redirectors
        every_869_4_0 += manager.dt;
        if (every_869_4_0 < 1.0) goto event_869_4_end;
        every_869_4_0 -= 1.0;
        screen_148_instances.clear_selection();
        objlasergun_201_instances.clear_selection();
        if (!check_overlap(screen_148_instances, objlasergun_201_instances)) goto event_869_4_end;
        if (frame_time - restrict_869_4 < 0.99) goto event_869_4_end;
        restrict_869_4 = frame_time;
        media.set_sample_volume(SOUND_ZAP_17, 0.3*global_values->get(12));
        media.play_id(SOUND_ZAP_17, -1, 1);
    }
    event_869_4_end: ;
}
void Frames::event_func_977()
{
    // event 870_4
    {
        // group: Laser redirectors
        enemylaser_202_instances.clear_selection();
        for (ObjectIterator it(enemylaser_202_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) < (8))) { it.deselect(); continue; }
        }
        if (!enemylaser_202_instances.has_selection()) goto event_870_4_end;
        for (ObjectIterator it(enemylaser_202_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(1, 1); // 'enemy-laser'
        }
    }
    event_870_4_end: ;
}
void Frames::event_func_978()
{
    // event 880_4
    {
        // group: Laser redirectors
        every_880_4_0 += manager.dt;
        if (every_880_4_0 < 1.0) goto event_880_4_end;
        every_880_4_0 -= 1.0;
        screenfar_277_instances.clear_selection();
        objlasergunorange_256_instances.clear_selection();
        if (!check_overlap(screenfar_277_instances, objlasergunorange_256_instances)) goto event_880_4_end;
        for (ObjectIterator it(objlasergunorange_256_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
        FrameObject * single_instance_880_4_1; single_instance_880_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(objlasergunorange_256_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_880_4_1 == NULL)
                    single_instance_880_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_880_4_1))->set_direction(((Active*)get_single(objlasergunorange_256_instances, default_active_instance))->get_direction());
    }
    event_880_4_end: ;
}
void Frames::event_func_979()
{
    // event 885_4
    {
        // group: Laser redirectors
        every_885_4_0 += manager.dt;
        if (every_885_4_0 < 1.0) goto event_885_4_end;
        every_885_4_0 -= 1.0;
        screen_148_instances.clear_selection();
        objlasergunorange_256_instances.clear_selection();
        if (!check_overlap(screen_148_instances, objlasergunorange_256_instances)) goto event_885_4_end;
        if (frame_time - restrict_885_4 < 1.0) goto event_885_4_end;
        restrict_885_4 = frame_time;
        media.set_sample_volume(SOUND_ZAP_17, 0.3*global_values->get(12));
        media.play_id(SOUND_ZAP_17, -1, 1);
    }
    event_885_4_end: ;
}
void Frames::event_func_980()
{
    // event 887_4
    {
        // group: Laser redirectors
        enemylaser_202_instances.clear_selection();
        for (ObjectIterator it(enemylaser_202_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!enemylaser_202_instances.has_selection()) goto event_887_4_end;
        for (ObjectIterator it(enemylaser_202_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_887_4_end: ;
}
void Frames::event_func_981()
{
    // event 893_4
    {
        // group: Enemy Gates
        if (!(is_player_pressed_once(1, CONTROL_BUTTON1))) goto event_893_4_end;
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_893_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(8)) == (0))) goto event_893_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_893_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, -10); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(2, 1); // 'Player'
    }
    event_893_4_end: ;
}
void Frames::event_func_982()
{
    // event 894_4
    {
        // group: Enemy Gates
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_894_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_894_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_894_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_894_4_end: ;
}
void Frames::event_func_983()
{
    // event 895_4
    {
        // group: Enemy Gates
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_895_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_895_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_895_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(15);
        }
    }
    event_895_4_end: ;
}
void Frames::event_func_984()
{
    // event 896_4
    {
        // group: Enemy Gates
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_896_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_896_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_896_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_896_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_896_4_end: ;
}
void Frames::event_func_985()
{
    // event 897_4
    {
        // group: Enemy Gates
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_897_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_897_4_end;
        if (!(is_player_pressed_once(1, CONTROL_BUTTON2))) goto event_897_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_897_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_897_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
            ((Active*)*it)->alterables->values.set(2, 55); // 'Sprite'
            ((Active*)*it)->start_animation();
        }
    }
    event_897_4_end: ;
}
void Frames::event_func_986()
{
    // event 898_4
    {
        // group: Enemy Gates
        detector_94_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(detector_94_instances, objenemygate_235_instances)) goto event_898_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) != (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_898_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_898_4_end;
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(16);
        }
    }
    event_898_4_end: ;
}
void Frames::event_func_987()
{
    // event 899_4
    {
        // group: Enemy Gates
        player_93_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(player_93_instances, objenemygate_235_instances)) goto event_899_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_899_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) >= (((Active*)get_single(objenemygate_235_instances, default_active_instance))->get_y()+18))) goto event_899_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()+(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(objenemygate_235_instances, default_active_instance))->get_y())-16);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_899_4_end: ;
}
void Frames::event_func_988()
{
    // event 900_4
    {
        // group: Enemy Gates
        player_93_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(player_93_instances, objenemygate_235_instances)) goto event_900_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_900_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_y()) < (((Active*)get_single(objenemygate_235_instances, default_active_instance))->get_y()+18))) goto event_900_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()-(((Active*)get_instance(player_93_instances))->get_y()-((Active*)get_single(objenemygate_235_instances, default_active_instance))->get_y())-22);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_900_4_end: ;
}
void Frames::event_func_989()
{
    // event 901_4
    {
        // group: Enemy Gates
        enemylonestar_233_instances.clear_selection();
        if (!check_not_overlap(enemylonestar_233_instances, screen_148_instances)) goto event_901_4_end;
        enemyevileye_244_instances.clear_selection();
        if (!check_not_overlap(enemyevileye_244_instances, screen_148_instances)) goto event_901_4_end;
        objenemygate_235_instances.clear_selection();
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 1); // 'obj-enemygate'
        }
    }
    event_901_4_end: ;
}
void Frames::event_func_990()
{
    // event 902_4
    {
        // group: Enemy Gates
        objenemygate_235_instances.clear_selection();
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_902_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            ((Active*)*it)->blend_color.set_alpha_coefficient(0);
        }
    }
    event_902_4_end: ;
}
void Frames::event_func_991()
{
    // event 903_4
    {
        // group: Enemy Gates
        objenemygate_235_instances.clear_selection();
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_903_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            ((Active*)*it)->blend_color.set_alpha_coefficient(175);
        }
    }
    event_903_4_end: ;
}
void Frames::event_func_992()
{
    // event 904_4
    bool or_result_904_4 = false;
    bool or_temp_result_904_4_0 = false;
    {
        // group: Enemy Gates
        enemyevileye_244_instances.clear_selection();
        screen_148_instances.clear_selection();
        if (!check_overlap(enemyevileye_244_instances, screen_148_instances)) goto or_event_904_4_0_end;
        or_result_904_4 = true;
        or_temp_result_904_4_0 = true;
    }
    or_event_904_4_0_end: ;
    enemyevileye_244_instances.clear_saved_selection();
    screen_148_instances.clear_saved_selection();
    if (or_temp_result_904_4_0) {
        enemyevileye_244_instances.save_selection();
        screen_148_instances.save_selection();
    }
    // event 904_4
    bool or_temp_result_904_4_1 = false;
    {
        // group: Enemy Gates
        enemylonestar_233_instances.clear_selection();
        screen_148_instances.clear_selection();
        if (!check_overlap(enemylonestar_233_instances, screen_148_instances)) goto or_event_904_4_1_end;
        or_result_904_4 = true;
        or_temp_result_904_4_1 = true;
        or_event_904_4_1_end: ;
        enemylonestar_233_instances.clear_saved_selection();
        if (or_temp_result_904_4_1) {
            enemylonestar_233_instances.save_selection();
            screen_148_instances.save_selection();
        }
        if (!or_result_904_4) goto or_final_or_event_904_4_1_end;
        screen_148_instances.clear_selection();
        enemylonestar_233_instances.clear_selection();
        enemyevileye_244_instances.clear_selection();
        if (or_temp_result_904_4_1) {
            enemylonestar_233_instances.restore_selection();
        }
        if (or_temp_result_904_4_0) {
            enemyevileye_244_instances.restore_selection();
        }
        if (or_temp_result_904_4_0 || or_temp_result_904_4_1) {
            screen_148_instances.restore_selection();
        }
        objenemygate_235_instances.clear_selection();
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 0); // 'obj-enemygate'
        }
    }
    or_final_or_event_904_4_1_end: ;
}
void Frames::event_func_993()
{
    // event 905_4
    {
        // group: Counter
        screen_148_instances.clear_selection();
        active8_9_instances.clear_selection();
        if (!check_overlap(screen_148_instances, active8_9_instances)) goto event_905_4_end;
        for (ObjectIterator it(active8_9_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(2, 1); // 'Active 8'
        }
    }
    event_905_4_end: ;
}
void Frames::event_func_994()
{
    // event 906_4
    {
        // group: Counter
        active8_9_instances.clear_selection();
        for (ObjectIterator it(active8_9_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) < (80))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) >= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(18)) { it.deselect(); continue; }
        }
        if (!active8_9_instances.has_selection()) goto event_906_4_end;
        for (ObjectIterator it(active8_9_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_906_4_end: ;
}
void Frames::event_func_995()
{
    // event 907_4
    {
        // group: Counter
        active8_9_instances.clear_selection();
        for (ObjectIterator it(active8_9_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) < (160))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) >= (80))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(18)) { it.deselect(); continue; }
        }
        if (!active8_9_instances.has_selection()) goto event_907_4_end;
        for (ObjectIterator it(active8_9_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(13);
        }
    }
    event_907_4_end: ;
}
