#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::col_28_4()
{
    event_func_241();
}
void Frames::event_func_242()
{
    // event 343_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
        media.stop_sample(SOUND_IMPAKT_35);
        media.play_id(SOUND_IMPAKT_35, -1, 1);
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
    }
    event_343_4_end: ;
}
void Frames::col_29_4()
{
    event_func_242();
}
void Frames::event_func_243()
{
    // event 340_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(2, 1); // 'enemy-rockiship'
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
        media.stop_sample(SOUND_IMPAKT_35);
        media.play_id(SOUND_IMPAKT_35, -1, 1);
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
    }
    event_340_4_end: ;
}
void Frames::col_30_4()
{
    event_func_243();
}
void Frames::event_func_244()
{
    // event 943_4
    {
        // group: Platform Spawners
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) == (1))) goto event_943_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, ((Active*)col_instance_2))) goto event_943_4_end;
        if (!(((Active*)col_instance_2)->test_animation(0))) goto event_943_4_end;
        FrameObject * single_instance_943_4_0; single_instance_943_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_vertplatform_106(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_943_4_0 == NULL)
                single_instance_943_4_0 = new_obj;
        }
        FrameObject * single_instance_943_4_1; single_instance_943_4_1 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_vertdetector_107(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_943_4_1 == NULL)
                single_instance_943_4_1 = new_obj;
        }
        ((Active*)((Active*)col_instance_2))->force_animation(1);
        media.play_id(SOUND_SPWNPLAT16MONO_18, -1, 1);
        media.set_sample_volume(SOUND_SPWNPLAT16MONO_18, 0.5*global_values->get(12));
    }
    event_943_4_end: ;
}
void Frames::col_31_4()
{
    event_func_244();
}
void Frames::event_func_245()
{
    // event 411_4
    {
        // group: Atom Bomb
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_411_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(5));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_411_4_end: ;
}
void Frames::col_32_4()
{
    event_func_245();
}
void Frames::event_func_246()
{
    // event 344_4
    {
        // group: More collisions
        if (!((((Active*)col_instance_1)->alterables->values.get(2)) == (2))) goto event_344_4_end;
        ((Active*)((Active*)col_instance_2))->destroy();
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
        media.stop_sample(SOUND_IMPAKT_35);
        media.play_id(SOUND_IMPAKT_35, -1, 1);
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
    }
    event_344_4_end: ;
}
void Frames::event_func_247()
{
    // event 552_4
    {
        // group: Drop Bro
        if (!(((Active*)col_instance_1)->test_directions(16777216))) goto event_552_4_end;
        ((Active*)((Active*)col_instance_1))->alterables->values.set(2, 1); // 'droppo-shot'
    }
    event_552_4_end: ;
}
void Frames::col_35_4()
{
    event_func_246();
    event_func_247();
}
void Frames::event_func_248()
{
    // event 1016_4
    {
        // group: Clockwork Block
        if (!((((Active*)col_instance_2)->alterables->values.get(2)) == (1))) goto event_1016_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_1016_4_end;
        if (!((((Active*)col_instance_1)->alterables->values.get(3)) < (3))) goto event_1016_4_end;
        if (not_always_1016_4_0 > loop_count) {
            not_always_1016_4_0 = loop_count + 2;
            goto event_1016_4_end;
        }
        not_always_1016_4_0 = loop_count + 2;
        media.set_sample_volume(SOUND_GETONGROUND_2, global_values->get(12)*0.4);
        media.play_id(SOUND_GETONGROUND_2, -1, 1);
        media.set_sample_volume(SOUND_GETONGROUND_2, global_values->get(12)*0.4);
    }
    event_1016_4_end: ;
}
void Frames::col_37_4()
{
    event_func_248();
}
void Frames::event_func_249()
{
    // event 539_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.set(1, 9); // 'enemy-zappa'
    }
    event_539_4_end: ;
}
void Frames::col_38_4()
{
    event_func_249();
}
void Frames::event_func_250()
{
    // event 652_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.set(1, -1); // 'spawner-evileye'
        ((Active*)((Active*)col_instance_1))->destroy();
    }
    event_652_4_end: ;
}
void Frames::col_39_4()
{
    event_func_250();
}
void Frames::event_func_251()
{
    // event 936_4
    {
        // group: Platform Spawners
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) == (0))) goto event_936_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, ((Active*)col_instance_2))) goto event_936_4_end;
        if (!(((Active*)col_instance_2)->test_animation(0))) goto event_936_4_end;
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
        FrameObject * single_instance_936_4_0; single_instance_936_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_movingplatform_97(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_936_4_0 == NULL)
                single_instance_936_4_0 = new_obj;
        }
        FrameObject * single_instance_936_4_1; single_instance_936_4_1 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_platform2_98(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_936_4_1 == NULL)
                single_instance_936_4_1 = new_obj;
        }
        ((Active*)((Active*)col_instance_2))->force_animation(1);
        media.play_id(SOUND_SPWNPLAT16MONO_18, -1, 1);
        media.set_sample_volume(SOUND_SPWNPLAT16MONO_18, 0.5*global_values->get(12));
    }
    event_936_4_end: ;
}
void Frames::col_40_4()
{
    event_func_251();
    event_func_244();
}
void Frames::event_func_252()
{
    // event 685_4
    {
        // group: Boxman
        if (!((((Active*)col_instance_2)->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) goto event_685_4_end;
        FrameObject * single_instance_685_4_0; single_instance_685_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyboxman_262(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_685_4_0 == NULL)
                single_instance_685_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_685_4_0))->set_direction(16);
    }
    event_685_4_end: ;
}
void Frames::event_func_253()
{
    // event 686_4
    {
        // group: Boxman
        if (!((((Active*)col_instance_2)->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()))) goto event_686_4_end;
        FrameObject * single_instance_686_4_0; single_instance_686_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyboxman_262(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_686_4_0 == NULL)
                single_instance_686_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_686_4_0))->set_direction(0);
    }
    event_686_4_end: ;
}
void Frames::col_41_4()
{
    event_func_252();
    event_func_253();
}
void Frames::event_func_254()
{
    // event 884_4
    {
        ((Active*)((Active*)col_instance_1))->set_visible(false);
        ((Active*)((Active*)col_instance_2))->set_direction(16);
    }
    event_884_4_end: ;
}
void Frames::col_42_4()
{
    event_func_254();
}
void Frames::event_func_255()
{
    // event 402_4
    {
        // group: Enemies
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_402_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
        global_values->sub(0, global_values->get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
    }
    event_402_4_end: ;
}
void Frames::col_45_4()
{
    event_func_255();
}
void Frames::event_func_256()
{
    // event 509_4
    {
        ((Active*)((Active*)col_instance_2))->set_direction(16);
    }
    event_509_4_end: ;
}
void Frames::col_47_4()
{
    event_func_256();
}
void Frames::event_func_257()
{
    // event 413_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        FrameObject * single_instance_413_4_0; single_instance_413_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_bigexplosion_177(((Active*)col_instance_1)->x + 0, ((Active*)col_instance_1)->y + 0), ((Active*)col_instance_1)->layer);
            if (single_instance_413_4_0 == NULL)
                single_instance_413_4_0 = new_obj;
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)col_instance_1)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)col_instance_1)->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(5);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 8); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 8); // 'camera shaker'
    }
    event_413_4_end: ;
}
void Frames::col_48_4()
{
    event_func_257();
}
void Frames::event_func_258()
{
    // event 223_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        media.play_id(SOUND_EYEBLOCK_14, -1, 1);
        media.set_sample_volume(SOUND_EYEBLOCK_14, 1*global_values->get(12));
    }
    event_223_4_end: ;
}
void Frames::event_func_259()
{
    // event 803_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->flags.toggle(0);
        ((Active*)((Active*)col_instance_1))->destroy();
    }
    event_803_4_end: ;
}
void Frames::col_50_4()
{
    event_func_258();
    event_func_259();
}
void Frames::event_func_260()
{
    // event 496_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(6, ((Active*)col_instance_1)->alterables->values.get(4)); // 'enemy-blobulule-phase2'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
    }
    event_496_4_end: ;
}
void Frames::event_func_261()
{
    // event 501_4
    {
        ((Active*)((Active*)col_instance_2))->force_animation(12);
    }
    event_501_4_end: ;
}
void Frames::col_51_4()
{
    event_func_225();
    event_func_260();
    event_func_261();
}
void Frames::event_func_262()
{
    // event 394_4
    {
        // group: Enemy Movers
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_394_4_end;
        global_values->sub(0, ((Active*)col_instance_1)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 95); // 'Player'
    }
    event_394_4_end: ;
}
void Frames::col_52_4()
{
    event_func_262();
}
void Frames::event_func_263()
{
    // event 987_4
    {
        // group: Incentives
        if (!((global_values->get(0)) <= (90.0))) goto event_987_4_end;
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) == (0))) goto event_987_4_end;
        global_values->add(0, 10);
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
    }
    event_987_4_end: ;
}
void Frames::event_func_264()
{
    // event 991_4
    {
        // group: Incentives
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) == (0))) goto event_991_4_end;
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 20); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 15); // 'camera shaker'
        media.stop_sample(SOUND_SQUEAKYBOOM_30);
        media.play_id(SOUND_SQUEAKYBOOM_30, -1, 1);
        media.set_sample_volume(SOUND_SQUEAKYBOOM_30, 0.8*global_values->get(12));
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)col_instance_2)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)col_instance_2)->get_y()); // 'FrameDataStore'
        global_values->add(2, 1);
        ((Active*)get_instance(uilivesactive_259_instances))->force_animation(12);
        global_values->set(14, ((Active*)col_instance_2)->alterables->values.get(1));
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1); // 'obj-bonus-time'
        {
            loop_debris_confetti_running = true;
            int times = int(20);
            loop_debris_confetti_index = 0;
            while (loop_debris_confetti_index < times) {
                loop_debris_confetti_4();
                if (!loop_debris_confetti_running) break;
                loop_debris_confetti_index++;
            }
        }
    }
    event_991_4_end: ;
}
void Frames::col_53_4()
{
    event_func_263();
    event_func_264();
}
void Frames::event_func_265()
{
    // event 882_4
    {
        ((Active*)((Active*)col_instance_1))->set_visible(false);
        ((Active*)((Active*)col_instance_2))->set_direction(0);
    }
    event_882_4_end: ;
}
void Frames::col_54_4()
{
    event_func_265();
}
void Frames::event_func_266()
{
    // event 535_4
    {
        FrameObject * single_instance_535_4_0; single_instance_535_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemydangerned_217(((Active*)col_instance_2)->get_action_x() - ((Active*)col_instance_2)->layer->off_x + 0, ((Active*)col_instance_2)->get_action_y() - ((Active*)col_instance_2)->layer->off_y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_535_4_0 == NULL)
                single_instance_535_4_0 = new_obj;
        }
    }
    event_535_4_end: ;
}
void Frames::col_56_4()
{
    event_func_266();
}
void Frames::event_func_267()
{
    // event 222_4
    {
        media.play_id(SOUND_EYEBLOCK_14, -1, 1);
        media.set_sample_volume(SOUND_EYEBLOCK_14, 1*global_values->get(12));
    }
    event_222_4_end: ;
}
void Frames::col_57_4()
{
    event_func_267();
    event_func_259();
}
void Frames::event_func_268()
{
    // event 1045_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.add(5, 1); // 'obj-junkblock'
    }
    event_1045_4_end: ;
}
void Frames::col_58_4()
{
    event_func_268();
}
void Frames::event_func_269()
{
    // event 674_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-toolio'
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 0); // 'enemy-toolio'
        ((Active*)((Active*)col_instance_2))->force_animation(2);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
    }
    event_674_4_end: ;
}
void Frames::col_59_4()
{
    event_func_269();
}
void Frames::event_func_270()
{
    // event 879_4
    {
        // group: Laser redirectors
        if (!(frame_time >= 0.06)) goto event_879_4_end;
        media.play_id(SOUND_ROTATE_PWIMP_28, -1, 1);
        media.set_sample_volume(SOUND_ROTATE_PWIMP_28, global_values->get(12)*0.35);
    }
    event_879_4_end: ;
}
void Frames::event_func_271()
{
    // event 888_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->set_direction(((Active*)col_instance_2)->get_direction()-8);
    }
    event_888_4_end: ;
}
void Frames::col_60_4()
{
    event_func_270();
    event_func_271();
}
void Frames::event_func_272()
{
    // event 502_4
    {
        FrameObject * single_instance_502_4_0; single_instance_502_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyblobululephase1_211(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_502_4_0 == NULL)
                single_instance_502_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_502_4_0))->alterables->values.set(2, ((Active*)single_instance_502_4_0)->get_y()); // 'enemy-blobulule-phase1'
    }
    event_502_4_end: ;
}
void Frames::col_61_4()
{
    event_func_272();
}
void Frames::event_func_273()
{
    // event 932_4
    {
        // group: Platform Spawners
        vertplatform_106_instances.clear_selection();
        if (!check_overlap(((Active*)col_instance_1), vertplatform_106_instances)) goto event_932_4_end;
        ((Active*)((Active*)col_instance_1))->destroy();
        for (ObjectIterator it(vertplatform_106_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_932_4_end: ;
}
void Frames::col_62_4()
{
    event_func_273();
}
void Frames::event_func_274()
{
    // event 432_4
    {
        // group: BrokenBrain
        if (!((((Active*)col_instance_2)->alterables->values.get(3)) <= (0))) goto event_432_4_end;
        FrameObject * single_instance_432_4_0; single_instance_432_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemybrokenrobot_192(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_432_4_0 == NULL)
                single_instance_432_4_0 = new_obj;
        }
        ((Active*)((Active*)col_instance_2))->alterables->values.set(3, 250); // 'spawnerbrokenrobot'
        ((Active*)((Active*)single_instance_432_4_0))->alterables->values.set(4, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(2)); // 'enemy-brokenrobot'
        FrameObject * single_instance_432_4_1; single_instance_432_4_1 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemybrokenrobottop_194(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_432_4_1 == NULL)
                single_instance_432_4_1 = new_obj;
        }
        FrameObject * single_instance_432_4_2; single_instance_432_4_2 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemybrokenrobotbottom_195(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_432_4_2 == NULL)
                single_instance_432_4_2 = new_obj;
        }
        ((Active*)((Active*)single_instance_432_4_1))->alterables->values.set(0, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(2)); // 'enemy-brokenrobot-top'
        ((Active*)((Active*)single_instance_432_4_2))->alterables->values.set(0, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(2)); // 'enemy-brokenrobot-bottom'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.add(2, 1); // 'FrameDataStore'
    }
    event_432_4_end: ;
}
void Frames::col_63_4()
{
    event_func_274();
}
void Frames::event_func_275()
{
    // event 225_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        media.play_id(SOUND_EYEBLOCK_14, -1, 1);
        media.set_sample_volume(SOUND_EYEBLOCK_14, 1*global_values->get(12));
    }
    event_225_4_end: ;
}
void Frames::event_func_276()
{
    // event 805_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->flags.toggle(0);
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_805_4_end: ;
}
void Frames::col_64_4()
{
    event_func_275();
    event_func_276();
}
void Frames::event_func_277()
{
    // event 542_4
    {
        FrameObject * single_instance_542_4_0; single_instance_542_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyzappa_220(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 12), ((Active*)col_instance_2)->layer);
            if (single_instance_542_4_0 == NULL)
                single_instance_542_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_542_4_0))->alterables->values.set(2, ((Active*)single_instance_542_4_0)->alterables->values.get(3)); // 'enemy-zappa'
    }
    event_542_4_end: ;
}
void Frames::col_65_4()
{
    event_func_277();
}
void Frames::event_func_278()
{
    // event 422_4
    {
        // group: Chomper
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_422_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(3));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_422_4_end: ;
}
void Frames::event_func_279()
{
    // event 430_4
    {
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_430_4_end: ;
}
void Frames::col_66_4()
{
    event_func_278();
    event_func_279();
}
void Frames::event_func_280()
{
    // event 423_4
    {
        // group: Chomper
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_423_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
        enemyzapball_185_instances.clear_selection();
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_423_4_end: ;
}
void Frames::col_67_4()
{
    event_func_280();
}
void Frames::event_func_281()
{
    // event 807_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->flags.toggle(0);
    }
    event_807_4_end: ;
}
void Frames::col_68_4()
{
    event_func_267();
    event_func_281();
}
void Frames::event_func_282()
{
    // event 290_4
    {
        // group: Crates
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_290_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 46); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 95); // 'Player'
    }
    event_290_4_end: ;
}
void Frames::col_69_4()
{
    event_func_282();
}
void Frames::event_func_283()
{
    // event 962_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        global_values->sub(10, -1);
        FrameObject * single_instance_962_4_0; single_instance_962_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_explosion_130(((Active*)col_instance_1)->x + 0, ((Active*)col_instance_1)->y + 0), ((Active*)col_instance_1)->layer);
            if (single_instance_962_4_0 == NULL)
                single_instance_962_4_0 = new_obj;
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)col_instance_1)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)col_instance_1)->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(15);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_962_4_end: ;
}
void Frames::col_70_4()
{
    event_func_283();
}
void Frames::event_func_284()
{
    // event 620_4
    {
        ((Active*)((Active*)col_instance_2))->get_movement()->bounce(Movement::COLLISION);
    }
    event_620_4_end: ;
}
void Frames::col_71_4()
{
    event_func_284();
}
void Frames::event_func_285()
{
    // event 844_4
    {
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, -15); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(5, 1); // 'Player'
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(19, 15); // 'Player'
    }
    event_844_4_end: ;
}
void Frames::col_72_4()
{
    event_func_285();
}
void Frames::event_func_286()
{
    // event 977_4
    {
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(4, 1); // 'FrameDataStore'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(5, 1); // 'camera shaker'
    }
    event_977_4_end: ;
}
void Frames::col_73_4()
{
    event_func_286();
}
void Frames::col_74_4()
{
    event_func_267();
}
void Frames::event_func_287()
{
    // event 398_4
    {
        // group: Shooter
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_398_4_end;
        global_values->sub(0, ((Active*)col_instance_1)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(2);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_398_4_end: ;
}
void Frames::col_75_4()
{
    event_func_287();
    event_func_224();
}
void Frames::event_func_288()
{
    // event 861_4
    {
        ((Active*)((Active*)col_instance_2))->set_direction(8);
        ((Active*)((Active*)col_instance_1))->set_visible(false);
    }
    event_861_4_end: ;
}
void Frames::col_76_4()
{
    event_func_288();
}
void Frames::event_func_289()
{
    // event 559_4
    {
        FrameObject * single_instance_559_4_0; single_instance_559_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemydroppo_222(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_559_4_0 == NULL)
                single_instance_559_4_0 = new_obj;
        }
    }
    event_559_4_end: ;
}
void Frames::col_77_4()
{
    event_func_289();
}
void Frames::col_78_4()
{
    event_func_209();
    event_func_224();
}
void Frames::event_func_290()
{
    // event 218_4
    {
        // group: Sounds
        if (!(frame_time >= 0.11)) goto event_218_4_end;
        media.play_id(SOUND_EYEBLOCK_14, -1, 1);
        media.set_sample_volume(SOUND_EYEBLOCK_14, 1*global_values->get(12));
    }
    event_218_4_end: ;
}
void Frames::event_func_291()
{
    // event 802_4
    {
        // group: Eyeblock
        if (frame_time - restrict_802_4 < 0.01) goto event_802_4_end;
        restrict_802_4 = frame_time;
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->alterables->flags.toggle(0);
    }
    event_802_4_end: ;
}
void Frames::event_func_292()
{
    // event 814_4
    {
        // group: Eyeblock
        if (!(loop_count <= 1)) goto event_814_4_end;
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->alterables->flags.toggle(0);
    }
    event_814_4_end: ;
}
void Frames::col_82_4()
{
    event_func_290();
    event_func_291();
    event_func_292();
}
void Frames::event_func_293()
{
    // event 312_4
    {
        // group: Hoppy Enemy
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_312_4_end;
        global_values->sub(0, ((Active*)col_instance_1)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_312_4_end: ;
}
void Frames::col_83_4()
{
    event_func_293();
}
void Frames::event_func_294()
{
    // event 214_4
    {
        media.play_id(SOUND_SPRING_4, -1, 1);
        media.set_sample_volume(SOUND_SPRING_4, global_values->get(12)*0.4);
    }
    event_214_4_end: ;
}
void Frames::col_84_4()
{
    event_func_294();
}
void Frames::event_func_295()
{
    // event 385_4
    {
        // group: Floaters
        screen_148_instances.clear_selection();
        if (!check_not_overlap(screen_148_instances, enemyfloater_165_instances)) goto event_385_4_end;
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_385_4_end: ;
}
