#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::col_85_4()
{
    event_func_295();
}
void Frames::event_func_296()
{
    // event 574_4
    {
        ((Active*)((Active*)col_instance_1))->get_movement()->bounce(Movement::COLLISION);
        ((Active*)((Active*)col_instance_1))->get_movement()->set_speed(0);
    }
    event_574_4_end: ;
}
void Frames::col_86_4()
{
    event_func_296();
}
void Frames::event_func_297()
{
    // event 193_4
    {
        // group: Sounds
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_193_4_end;
        media.play_id(SOUND_DISAPPEARINGBLOCK_3_8, -1, 1);
        media.set_sample_volume(SOUND_DISAPPEARINGBLOCK_3_8, global_values->get(12)*1.0);
    }
    event_193_4_end: ;
}
void Frames::event_func_298()
{
    // event 775_4
    {
        // group: Disappearing Blocks
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_775_4_end;
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            if (((Active*)(*it))->test_animation(21)) { it.deselect(); continue; }
        }
        if (!sprite_99_instances.has_selection()) goto event_775_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.set(1, 1); // 'dissappear'
    }
    event_775_4_end: ;
}
void Frames::col_88_4()
{
    event_func_297();
    event_func_298();
}
void Frames::event_func_299()
{
    // event 302_4
    {
        ((Active*)((Active*)col_instance_2))->get_movement()->set_speed(250);
        ((Active*)((Active*)col_instance_2))->set_direction(8);
        ((Active*)((Active*)col_instance_1))->force_animation(12);
        ((Active*)((Active*)col_instance_2))->get_movement()->set_gravity(8);
        ((Active*)((Active*)col_instance_2))->get_movement()->set_deceleration(0);
    }
    event_302_4_end: ;
}
void Frames::col_90_4()
{
    event_func_299();
}
void Frames::col_91_4()
{
    event_func_276();
}
void Frames::event_func_300()
{
    // event 715_4
    {
        // group: Bouncer
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, ((Active*)col_instance_2))) goto event_715_4_end;
        media.play_id(SOUND_THWAP_24, -1, 1);
        media.set_sample_volume(SOUND_THWAP_24, 0.25*global_values->get(12));
    }
    event_715_4_end: ;
}
void Frames::col_93_4()
{
    event_func_284();
    event_func_300();
}
void Frames::event_func_301()
{
    // event 695_4
    {
        ((Active*)((Active*)col_instance_1))->get_movement()->bounce(Movement::COLLISION);
        ((Active*)((Active*)col_instance_1))->alterables->values.set(0, 0); // 'enemy-boxman'
    }
    event_695_4_end: ;
}
void Frames::col_94_4()
{
    event_func_301();
}
void Frames::event_func_302()
{
    // event 866_4
    {
        {
            FrameObject * parent = ((Active*)col_instance_1);
            if (parent == NULL) goto pos_end_866_4_0;
            ((Active*)col_instance_2)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_866_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->set_direction(16);
    }
    event_866_4_end: ;
}
void Frames::col_97_4()
{
    event_func_302();
}
void Frames::event_func_303()
{
    // event 215_4
    {
        // group: Sounds
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_215_4_end;
        media.play_id(SOUND_SPRING_4, -1, 1);
        media.set_sample_volume(SOUND_SPRING_4, global_values->get(12)*0.4);
    }
    event_215_4_end: ;
}
void Frames::col_98_4()
{
    event_func_303();
}
void Frames::event_func_304()
{
    // event 327_4
    {
        // group: Hoppy Enemy
        screen_148_instances.clear_selection();
        if (!check_not_overlap(screen_148_instances, enemyhoppy_152_instances)) goto event_327_4_end;
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_327_4_end: ;
}
void Frames::col_99_4()
{
    event_func_304();
}
void Frames::event_func_305()
{
    // event 853_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.set(17, 1); // 'Player'
    }
    event_853_4_end: ;
}
void Frames::col_100_4()
{
    event_func_305();
}
void Frames::event_func_306()
{
    // event 846_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.set(12, 1200); // 'Player'
    }
    event_846_4_end: ;
}
void Frames::col_101_4()
{
    event_func_306();
}
void Frames::event_func_307()
{
    // event 303_4
    {
        // group: Crates
        if (!((((Active*)col_instance_1)->alterables->values.get(0)) < (0))) goto event_303_4_end;
        if (!((((Active*)col_instance_2)->get_movement()->get_speed()) < (3))) goto event_303_4_end;
        ((Active*)((Active*)col_instance_1))->alterables->values.set(0, 1); // 'Player'
    }
    event_303_4_end: ;
}
void Frames::col_103_4()
{
    event_func_307();
}
void Frames::event_func_308()
{
    // event 883_4
    {
        ((Active*)((Active*)col_instance_1))->set_visible(false);
        ((Active*)((Active*)col_instance_2))->set_direction(8);
    }
    event_883_4_end: ;
}
void Frames::col_104_4()
{
    event_func_308();
}
void Frames::event_func_309()
{
    // event 309_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'Enemy-Hoppy'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 9); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 9); // 'camera shaker'
    }
    event_309_4_end: ;
}
void Frames::col_105_4()
{
    event_func_225();
    event_func_309();
}
void Frames::event_func_310()
{
    // event 707_4
    {
        // group: Bouncer
        if (!((((Active*)col_instance_2)->alterables->values.get(2)) == (1))) goto event_707_4_end;
        ((Active*)((Active*)col_instance_1))->get_movement()->bounce(Movement::COLLISION);
    }
    event_707_4_end: ;
}
void Frames::event_func_311()
{
    // event 713_4
    {
        // group: Bouncer
        if (!((((Active*)col_instance_2)->alterables->values.get(2)) == (1))) goto event_713_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, ((Active*)col_instance_1))) goto event_713_4_end;
        media.play_id(SOUND_THWAP_24, -1, 1);
        media.set_sample_volume(SOUND_THWAP_24, 0.25*global_values->get(12));
    }
    event_713_4_end: ;
}
void Frames::col_106_4()
{
    event_func_310();
    event_func_311();
}
void Frames::col_107_4()
{
    event_func_275();
}
void Frames::event_func_312()
{
    // event 680_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-boxman'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
    }
    event_680_4_end: ;
}
void Frames::col_108_4()
{
    event_func_225();
    event_func_312();
}
void Frames::event_func_313()
{
    // event 442_4
    {
        // group: BrokenBrain
        if (!((((Active*)col_instance_1)->alterables->values.get(5)) > (1))) goto event_442_4_end;
        enemybrokenrobottop_194_instances.clear_selection();
        if (!check_overlap(((Active*)col_instance_2), enemybrokenrobottop_194_instances)) goto event_442_4_end;
        enemybrokenrobotbottom_195_instances.clear_selection();
        if (!check_overlap(((Active*)col_instance_2), enemybrokenrobotbottom_195_instances)) goto event_442_4_end;
        if (!((((Active*)col_instance_2)->alterables->values.get(4)) == (((Active*)get_single(enemybrokenrobotbottom_195_instances, default_active_instance))->alterables->values.get(0)))) goto event_442_4_end;
        if (!((((Active*)col_instance_2)->alterables->values.get(4)) == (((Active*)get_single(enemybrokenrobottop_194_instances, default_active_instance))->alterables->values.get(0)))) goto event_442_4_end;
        FrameObject * single_instance_442_4_0; single_instance_442_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_explosion_130(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_442_4_0 == NULL)
                single_instance_442_4_0 = new_obj;
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)col_instance_2)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)col_instance_2)->get_y()); // 'FrameDataStore'
        ((Active*)((Active*)col_instance_2))->destroy();
        for (ObjectIterator it(enemybrokenrobottop_194_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        for (ObjectIterator it(enemybrokenrobotbottom_195_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_442_4_end: ;
}
void Frames::col_109_4()
{
    event_func_313();
}
void Frames::event_func_314()
{
    // event 917_4
    {
        FrameObject * single_instance_917_4_0; single_instance_917_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_active8_203(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_917_4_0 == NULL)
                single_instance_917_4_0 = new_obj;
        }
        ((Active*)((Active*)col_instance_2))->alterables->values.set(3, 250); // 'counter-spawner'
    }
    event_917_4_end: ;
}
void Frames::col_110_4()
{
    event_func_314();
}
void Frames::event_func_315()
{
    // event 519_4
    {
        // group: MobileBro
        if (!((((Active*)get_instance(cameratarget_248_instances))->get_y()) > (((Active*)col_instance_2)->get_y()*((Active*)col_instance_2)->alterables->values.get(1)))) goto event_519_4_end;
        FrameObject * single_instance_519_4_0; single_instance_519_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemymobilebrohoriz_214(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_519_4_0 == NULL)
                single_instance_519_4_0 = new_obj;
        }
    }
    event_519_4_end: ;
}
void Frames::col_111_4()
{
    event_func_315();
}
void Frames::event_func_316()
{
    // event 241_4
    {
        // group: Sounds
        screen_148_instances.clear_selection();
        if (!check_overlap(((Active*)col_instance_1), screen_148_instances)) goto event_241_4_end;
        media.stop_sample(SOUND_EYEBLOCK_ALT_29);
        media.play_id(SOUND_EYEBLOCK_ALT_29, -1, 1);
        media.set_sample_volume(SOUND_EYEBLOCK_ALT_29, global_values->get(12)*0.18);
    }
    event_241_4_end: ;
}
void Frames::event_func_317()
{
    // event 812_4
    {
        // group: Eyeblock
        if (!(frame_time >= 0.03)) goto event_812_4_end;
        ((Active*)((Active*)col_instance_1))->alterables->flags.toggle(0);
    }
    event_812_4_end: ;
}
void Frames::event_func_318()
{
    // event 886_4
    {
        // group: Laser redirectors
        if (!((((Active*)col_instance_2)->alterables->values.get(2)) == (1))) goto event_886_4_end;
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_886_4_end: ;
}
void Frames::col_112_4()
{
    event_func_316();
    event_func_317();
    event_func_318();
}
void Frames::event_func_319()
{
    // event 759_4
    {
        // group: Lonestar New
        if (!((((Active*)col_instance_2)->alterables->values.get(7)) == (0))) goto event_759_4_end;
        ((Active*)((Active*)col_instance_2))->force_animation(15);
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-lonestarnew'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 6); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 5); // 'camera shaker'
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
    }
    event_759_4_end: ;
}
void Frames::event_func_320()
{
    // event 760_4
    {
        // group: Lonestar New
        if (!((((Active*)col_instance_2)->alterables->values.get(7)) == (1))) goto event_760_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-lonestarnew'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 6); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 5); // 'camera shaker'
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->force_animation(14);
    }
    event_760_4_end: ;
}
void Frames::col_113_4()
{
    event_func_225();
    event_func_319();
    event_func_320();
}
void Frames::event_func_321()
{
    // event 618_4
    {
        // group: Lonestar Jr
        if (!((((Active*)col_instance_1)->alterables->values.get(1)) >= (8))) goto event_618_4_end;
        if (!((((Active*)col_instance_2)->alterables->values.get(7)) == (0))) goto event_618_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-lonestar'
        ((Active*)((Active*)col_instance_2))->force_animation(14);
    }
    event_618_4_end: ;
}
void Frames::event_func_322()
{
    // event 619_4
    {
        // group: Lonestar Jr
        if (!((((Active*)col_instance_2)->alterables->values.get(7)) == (1))) goto event_619_4_end;
        if (!((((Active*)col_instance_1)->alterables->values.get(1)) >= (8))) goto event_619_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'enemy-lonestar'
        ((Active*)((Active*)col_instance_2))->force_animation(15);
    }
    event_619_4_end: ;
}
void Frames::col_115_4()
{
    event_func_321();
    event_func_322();
}
void Frames::event_func_323()
{
    // event 636_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'enemy-evileye'
        ((Active*)((Active*)col_instance_2))->force_animation(14);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
    }
    event_636_4_end: ;
}
void Frames::event_func_324()
{
    // event 638_4
    {
        // group: Evil Eye
        if (!((((Active*)col_instance_1)->alterables->values.get(3)) == (1))) goto event_638_4_end;
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.add(2, 5); // 'enemy-evileye'
    }
    event_638_4_end: ;
}
void Frames::event_func_325()
{
    // event 639_4
    {
        // group: Evil Eye
        if (!((((Active*)col_instance_1)->alterables->values.get(3)) != (1))) goto event_639_4_end;
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.add(2, -5); // 'enemy-evileye'
    }
    event_639_4_end: ;
}
void Frames::col_116_4()
{
    event_func_225();
    event_func_323();
    event_func_324();
    event_func_325();
}
void Frames::event_func_326()
{
    // event 300_4
    {
        // group: Crates
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) == (0))) goto event_300_4_end;
        FrameObject * single_instance_300_4_0; single_instance_300_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_tntstatic_131(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_300_4_0 == NULL)
                single_instance_300_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_300_4_0))->set_x(((Active*)col_instance_2)->get_x());
        ((Active*)((Active*)single_instance_300_4_0))->alterables->values.set(0, ((Active*)col_instance_2)->get_x()); // 'TNT-static'
        ((Active*)((Active*)single_instance_300_4_0))->alterables->values.set(1, ((Active*)col_instance_2)->get_x()); // 'TNT-static'
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1); // 'obj-tntspawner'
    }
    event_300_4_end: ;
}
void Frames::col_118_4()
{
    event_func_326();
}
void Frames::event_func_327()
{
    // event 352_4
    {
        ((Active*)((Active*)col_instance_2))->force_animation(13);
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'SpikeShooter'
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
    }
    event_352_4_end: ;
}
void Frames::col_119_4()
{
    event_func_225();
    event_func_327();
}
void Frames::event_func_328()
{
    // event 667_4
    {
        ((Active*)((Active*)col_instance_2))->get_movement()->set_speed(-25);
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(2, 1); // 'enemy-homing-cog'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 4); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 4); // 'camera shaker'
    }
    event_667_4_end: ;
}
void Frames::col_120_4()
{
    event_func_225();
    event_func_328();
}
void Frames::event_func_329()
{
    // event 641_4
    {
        // group: Evil Eye
        if (!((((Active*)col_instance_2)->alterables->values.get(0)) <= (0))) goto event_641_4_end;
        if (!((((Active*)get_instance(cameratarget_248_instances))->get_y()) > (((Active*)col_instance_2)->get_y()*((Active*)col_instance_2)->alterables->values.get(1)))) goto event_641_4_end;
        FrameObject * single_instance_641_4_0; single_instance_641_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyevileye_244(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_641_4_0 == NULL)
                single_instance_641_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_641_4_0))->alterables->values.set(8, 1); // 'enemy-evileye'
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 480); // 'spawner-snipereye'
    }
    event_641_4_end: ;
}
void Frames::col_122_4()
{
    event_func_329();
}
void Frames::event_func_330()
{
    // event 789_4
    {
        ((Active*)((Active*)col_instance_1))->set_direction(16);
        ((Active*)((Active*)col_instance_1))->alterables->values.set(2, 0); // 'Bullet'
        ((Active*)((Active*)col_instance_1))->alterables->values.set(3, -1); // 'Bullet'
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_789_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_789_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1.2); // 'SendLeft'
    }
    event_789_4_end: ;
}
void Frames::col_125_4()
{
    event_func_330();
}
void Frames::event_func_331()
{
    // event 994_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->alterables->values.add(1, 50); // 'obj-bonus-time'
    }
    event_994_4_end: ;
}
void Frames::col_126_4()
{
    event_func_331();
}
void Frames::event_func_332()
{
    // event 916_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->force_animation(18);
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 1); // 'Active 8'
    }
    event_916_4_end: ;
}
void Frames::col_127_4()
{
    event_func_225();
    event_func_332();
}
void Frames::event_func_333()
{
    // event 889_4
    {
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->set_direction(((Active*)col_instance_2)->get_direction()-8);
    }
    event_889_4_end: ;
}
void Frames::col_128_4()
{
    event_func_333();
}
void Frames::event_func_334()
{
    // event 426_4
    {
        FrameObject * single_instance_426_4_0; single_instance_426_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemychomper_184(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_426_4_0 == NULL)
                single_instance_426_4_0 = new_obj;
        }
    }
    event_426_4_end: ;
}
void Frames::col_129_4()
{
    event_func_334();
}
void Frames::event_func_335()
{
    // event 306_4
    {
        // group: Health/lives
        if (not_always_306_4_0 > loop_count) {
            not_always_306_4_0 = loop_count + 2;
            goto event_306_4_end;
        }
        not_always_306_4_0 = loop_count + 2;
        global_values->sub(0, 10);
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
    }
    event_306_4_end: ;
}
void Frames::col_130_4()
{
    event_func_335();
}
void Frames::event_func_336()
{
    // event 653_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->alterables->values.set(1, 1); // 'spawner-snipereye'
    }
    event_653_4_end: ;
}
void Frames::col_132_4()
{
    event_func_336();
}
void Frames::event_func_337()
{
    // event 517_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'enemy-mobilebrohoriz'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 5); // 'camera shaker'
    }
    event_517_4_end: ;
}
void Frames::col_136_4()
{
    event_func_225();
    event_func_337();
}
void Frames::col_137_4()
{
    event_func_292();
}
void Frames::event_func_338()
{
    // event 786_4
    {
        ((Active*)((Active*)col_instance_1))->set_direction(8);
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1.2); // 'SendUp'
        ((Active*)((Active*)col_instance_1))->alterables->values.set(2, -1); // 'Bullet'
        ((Active*)((Active*)col_instance_1))->alterables->values.set(3, 0); // 'Bullet'
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_786_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_786_4_0: ;
        }
    }
    event_786_4_end: ;
}
void Frames::col_138_4()
{
    event_func_338();
}
void Frames::event_func_339()
{
    // event 701_4
    {
        // group: Bouncer
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_701_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(1));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_701_4_end: ;
}
void Frames::col_140_4()
{
    event_func_339();
}
void Frames::event_func_340()
{
    // event 467_4
    {
        // group: Cross-enemy
        if (!((((Active*)col_instance_1)->alterables->values.get(1)) >= (8))) goto event_467_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 2); // 'enemy-mobilebrohoriz'
        ((Active*)((Active*)col_instance_2))->force_animation(14);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
        media.play_id(SOUND_ENEMYHIT_3, 32-1);
        media.set_sample_volume(SOUND_ENEMYHIT_3, global_values->get(12)*0.45);
    }
    event_467_4_end: ;
}
void Frames::col_141_4()
{
    event_func_340();
}
void Frames::event_func_341()
{
    // event 703_4
    {
        FrameObject * single_instance_703_4_0; single_instance_703_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemygearoflaw_264(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_703_4_0 == NULL)
                single_instance_703_4_0 = new_obj;
        }
    }
    event_703_4_end: ;
}
void Frames::col_143_4()
{
    event_func_341();
}
void Frames::event_func_342()
{
    // event 565_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        FrameObject * single_instance_565_4_0; single_instance_565_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyrockiship_227(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_565_4_0 == NULL)
                single_instance_565_4_0 = new_obj;
        }
    }
    event_565_4_end: ;
}
void Frames::col_144_4()
{
    event_func_342();
}
void Frames::event_func_343()
{
    // event 507_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.set(2, ((Active*)col_instance_1)->alterables->values.get(2)*-1); // 'enemy-mobilebrohoriz'
        ((Active*)((Active*)col_instance_1))->alterables->values.set(3, ((Active*)col_instance_1)->alterables->values.get(3)*-1); // 'enemy-mobilebrohoriz'
    }
    event_507_4_end: ;
}
void Frames::col_145_4()
{
    event_func_343();
}
void Frames::event_func_344()
{
    // event 788_4
    {
        ((Active*)((Active*)col_instance_1))->set_direction(24);
        ((Active*)((Active*)col_instance_1))->alterables->values.set(2, 1); // 'Bullet'
        ((Active*)((Active*)col_instance_1))->alterables->values.set(3, 0); // 'Bullet'
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_788_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_788_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1.2); // 'SendDown'
    }
    event_788_4_end: ;
}
void Frames::col_146_4()
{
    event_func_344();
}
void Frames::event_func_345()
{
    // event 522_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
        ((Active*)((Active*)col_instance_2))->alterables->values.set(1, 1); // 'spawner-mobilebro'
    }
    event_522_4_end: ;
}
void Frames::col_148_4()
{
    event_func_345();
}
void Frames::event_func_346()
{
    // event 466_4
    {
        // group: Cross-enemy
        if (!((((Active*)col_instance_1)->alterables->values.get(1)) >= (8))) goto event_466_4_end;
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, 2); // 'enemy-evileye'
        ((Active*)((Active*)col_instance_2))->force_animation(14);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
        media.play_id(SOUND_ENEMYHIT_3, 32-1);
        media.set_sample_volume(SOUND_ENEMYHIT_3, global_values->get(12)*0.45);
    }
    event_466_4_end: ;
}
void Frames::col_150_4()
{
    event_func_346();
}
void Frames::event_func_347()
{
    // event 865_4
    {
        {
            FrameObject * parent = ((Active*)col_instance_1);
            if (parent == NULL) goto pos_end_865_4_0;
            ((Active*)col_instance_2)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_865_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->set_direction(8);
    }
    event_865_4_end: ;
}
void Frames::col_151_4()
{
    event_func_347();
}
