#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::event_func_696()
{
    // event 436_4
    {
        // group: BrokenBrain
        bullet_121_instances.clear_selection();
        enemybrokenrobottop_194_instances.clear_selection();
        if (!check_overlap(bullet_121_instances, enemybrokenrobottop_194_instances)) goto event_436_4_end;
        enemybrokenrobot_192_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobottop_194_instances)) goto event_436_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (((Active*)get_single(enemybrokenrobottop_194_instances, default_active_instance))->alterables->values.get(0)))) { it.deselect(); continue; }
        }
        if (!enemybrokenrobot_192_instances.has_selection()) goto event_436_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()+(3*0.14*get_abs(((Active*)get_single(bullet_121_instances, it.current_index, default_active_instance))->alterables->values.get(0))));
        }
    }
    event_436_4_end: ;
}
void Frames::event_func_697()
{
    // event 437_4
    {
        // group: BrokenBrain
        bullet_121_instances.clear_selection();
        enemybrokenrobotbottom_195_instances.clear_selection();
        if (!check_overlap(bullet_121_instances, enemybrokenrobotbottom_195_instances)) goto event_437_4_end;
        enemybrokenrobot_192_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobotbottom_195_instances)) goto event_437_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (((Active*)get_single(enemybrokenrobotbottom_195_instances, default_active_instance))->alterables->values.get(0)))) { it.deselect(); continue; }
        }
        if (!enemybrokenrobot_192_instances.has_selection()) goto event_437_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-(3*0.14*get_abs(((Active*)get_single(bullet_121_instances, it.current_index, default_active_instance))->alterables->values.get(0))));
        }
    }
    event_437_4_end: ;
}
void Frames::event_func_698()
{
    // event 438_4
    {
        // group: BrokenBrain
        player_93_instances.clear_selection();
        enemybrokenrobot_192_instances.clear_selection();
        if (!check_overlap(player_93_instances, enemybrokenrobot_192_instances)) goto event_438_4_end;
        enemybrokenrobottop_194_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobottop_194_instances)) goto event_438_4_end;
        enemybrokenrobotbottom_195_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobotbottom_195_instances)) goto event_438_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(4)) != (0))) goto event_438_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        for (ObjectIterator it(enemybrokenrobotbottom_195_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        for (ObjectIterator it(enemybrokenrobottop_194_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemybrokenrobot_192_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemybrokenrobot_192_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_438_4_0; single_instance_438_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemybrokenrobot_192_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_438_4_0 == NULL)
                    single_instance_438_4_0 = new_obj;
            }
        }
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_438_4_end: ;
}
void Frames::event_func_699()
{
    // event 440_4
    {
        // group: BrokenBrain
        enemybrokenrobot_192_instances.clear_selection();
        if (!check_not_overlap(enemybrokenrobot_192_instances, enemybrokenrobottop_194_instances)) goto event_440_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_440_4_end: ;
}
void Frames::event_func_700()
{
    // event 441_4
    {
        // group: BrokenBrain
        enemybrokenrobot_192_instances.clear_selection();
        if (!check_not_overlap(enemybrokenrobot_192_instances, enemybrokenrobotbottom_195_instances)) goto event_441_4_end;
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_441_4_end: ;
}
void Frames::event_func_701()
{
    // event 445_4
    {
        // group: Walker
        every_445_4_0 += manager.dt;
        if (every_445_4_0 < 0.01) goto event_445_4_end;
        every_445_4_0 -= 0.01;
        spawnerwalker_197_instances.clear_selection();
        for (ObjectIterator it(spawnerwalker_197_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) > (0))) { it.deselect(); continue; }
        }
        if (!spawnerwalker_197_instances.has_selection()) goto event_445_4_end;
        for (ObjectIterator it(spawnerwalker_197_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(3, 1); // 'spawnerwalker'
        }
    }
    event_445_4_end: ;
}
void Frames::event_func_702()
{
    // event 446_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->alterables->values.get(4)+((Active*)*it)->alterables->values.get(2));
            ((Active*)*it)->alterables->values.add(2, ((Active*)*it)->alterables->values.get(6)); // 'enemy-walker'
        }
    }
    event_446_4_end: ;
}
void Frames::event_func_703()
{
    // event 447_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(7)) == (1))) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_447_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, 2); // 'enemy-walker'
            ((Active*)*it)->alterables->values.add(2, 7); // 'enemy-walker'
        }
    }
    event_447_4_end: ;
}
void Frames::event_func_704()
{
    // event 448_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(7)) == (0))) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_448_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, -2); // 'enemy-walker'
            ((Active*)*it)->alterables->values.add(2, -7); // 'enemy-walker'
        }
    }
    event_448_4_end: ;
}
void Frames::event_func_705()
{
    // event 449_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) < (0))) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_449_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(7, 1); // 'enemy-walker'
        }
    }
    event_449_4_end: ;
}
void Frames::event_func_706()
{
    // event 450_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) > (0))) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_450_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-walker'
        }
    }
    event_450_4_end: ;
}
void Frames::event_func_707()
{
    // event 451_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) < (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(0)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(13)) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_451_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_451_4_end: ;
}
void Frames::event_func_708()
{
    // event 452_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) > (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(1)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(13)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_452_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_452_4_end: ;
}
void Frames::event_func_709()
{
    // event 457_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemywalker_196_instances.has_selection()) goto event_457_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_457_4_0; single_instance_457_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemywalker_196_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_457_4_0 == NULL)
                    single_instance_457_4_0 = new_obj;
            }
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemywalker_196_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemywalker_196_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_457_4_end: ;
}
void Frames::event_func_710()
{
    // event 459_4
    {
        // group: Walker
        if (!((((Active*)get_instance(active6_7_instances))->alterables->values.get(0)) >= (60))) goto event_459_4_end;
        FrameObject * single_instance_459_4_0; single_instance_459_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * parent = ((Active*)get_instance(active6_7_instances));
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemywalker_196(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_459_4_0 == NULL)
                    single_instance_459_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_459_4_0))->alterables->values.set(5, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(2)); // 'enemy-walker'
        ((Active*)((Active*)single_instance_459_4_0))->alterables->values.set(6, -2); // 'enemy-walker'
        ((Active*)((Active*)single_instance_459_4_0))->alterables->values.set(4, ((Active*)single_instance_459_4_0)->get_x()); // 'enemy-walker'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.add(2, 1); // 'FrameDataStore'
        ((Active*)get_instance(active6_7_instances))->alterables->values.set(0, 0); // 'Active 6'
    }
    event_459_4_end: ;
}
void Frames::event_func_711()
{
    // event 460_4
    {
        // group: Walker
        screenfar_277_instances.clear_selection();
        active6_7_instances.clear_selection();
        if (!check_overlap(screenfar_277_instances, active6_7_instances)) goto event_460_4_end;
        ((Active*)get_instance(active6_7_instances))->alterables->values.add(0, 1); // 'Active 6'
    }
    event_460_4_end: ;
}
void Frames::event_func_712()
{
    // event 462_4
    {
        // group: Walker
        enemywalker_196_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(enemywalker_196_instances, objeyeblock_169_instances)) goto event_462_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_462_4_end;
        for (ObjectIterator it(enemywalker_196_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 2); // 'enemy-walker'
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-2);
        }
    }
    event_462_4_end: ;
}
void Frames::event_func_713()
{
    // event 468_4
    {
        // group: Blobulule
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->alterables->values.get(2));
        }
    }
    event_468_4_end: ;
}
void Frames::event_func_714()
{
    // event 469_4
    {
        // group: Blobulule
        if (!((((Active*)get_instance(player_93_instances))->get_x()) > (((Active*)get_instance(enemyblobululephase1_211_instances, default_active_instance))->get_x()))) goto event_469_4_end;
        if (((Active*)get_instance(active6_7_instances))->overlaps_background()) goto event_469_4_end;
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(0);
        }
    }
    event_469_4_end: ;
}
void Frames::event_func_715()
{
    // event 470_4
    {
        // group: Blobulule
        if (!((((Active*)get_instance(player_93_instances))->get_x()) < (((Active*)get_instance(enemyblobululephase1_211_instances, default_active_instance))->get_x()))) goto event_470_4_end;
        if (((Active*)get_instance(active6_7_instances))->overlaps_background()) goto event_470_4_end;
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
        }
    }
    event_470_4_end: ;
}
void Frames::event_func_716()
{
    // event 473_4
    {
        // group: Blobulule
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+85))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase1_211_instances.has_selection()) goto event_473_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) < (((Active*)get_single(enemyblobululephase1_211_instances, default_active_instance))->get_x()))) goto event_473_4_end;
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_473_4_0; single_instance_473_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase1_211_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyblobululephase2_212(parent->x + 0, parent->y + 16), parent->layer);
                if (single_instance_473_4_0 == NULL)
                    single_instance_473_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_473_4_0))->alterables->values.set(0, ((Active*)single_instance_473_4_0)->get_x()); // 'enemy-blobulule-phase2'
        ((Active*)((Active*)single_instance_473_4_0))->force_animation(8);
    }
    event_473_4_end: ;
}
void Frames::event_func_717()
{
    // event 474_4
    {
        // group: Blobulule
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-85))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase1_211_instances.has_selection()) goto event_474_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) > (((Active*)get_single(enemyblobululephase1_211_instances, default_active_instance))->get_x()))) goto event_474_4_end;
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_474_4_0; single_instance_474_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase1_211_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyblobululephase2_212(parent->x + 0, parent->y + 16), parent->layer);
                if (single_instance_474_4_0 == NULL)
                    single_instance_474_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_474_4_0))->alterables->values.set(0, ((Active*)single_instance_474_4_0)->get_x()); // 'enemy-blobulule-phase2'
        ((Active*)((Active*)single_instance_474_4_0))->force_animation(8);
    }
    event_474_4_end: ;
}
void Frames::event_func_718()
{
    // event 477_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) == (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_477_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(8);
        }
    }
    event_477_4_end: ;
}
void Frames::event_func_719()
{
    // event 478_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) <= (5))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(3)) == (1))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_478_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_478_4_end: ;
}
void Frames::event_func_720()
{
    // event 479_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->alterables->values.get(0));
            ((Active*)*it)->alterables->values.add(1, 1); // 'enemy-blobulule-phase2'
            ((Active*)*it)->alterables->values.add(0, ((Active*)*it)->alterables->values.get(2)); // 'enemy-blobulule-phase2'
            ((Active*)*it)->alterables->values.add(4, 1); // 'enemy-blobulule-phase2'
        }
    }
    event_479_4_end: ;
}
void Frames::event_func_721()
{
    // event 480_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) >= (40))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_480_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) > (((Active*)get_single(enemyblobululephase2_212_instances, default_active_instance))->get_x()))) goto event_480_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 0.5); // 'enemy-blobulule-phase2'
            ((Active*)*it)->alterables->values.set(1, 0); // 'enemy-blobulule-phase2'
        }
    }
    event_480_4_end: ;
}
void Frames::event_func_722()
{
    // event 481_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) >= (40))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_481_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) < (((Active*)get_single(enemyblobululephase2_212_instances, default_active_instance))->get_x()))) goto event_481_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, -0.5); // 'enemy-blobulule-phase2'
            ((Active*)*it)->alterables->values.set(1, 0); // 'enemy-blobulule-phase2'
        }
    }
    event_481_4_end: ;
}
void Frames::event_func_723()
{
    // event 482_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_482_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 2); // 'enemy-blobulule-phase2'
        }
    }
    event_482_4_end: ;
}
void Frames::event_func_724()
{
    // event 483_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) >= (7))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_movement()->get_speed()) <= (5))) { it.deselect(); continue; }
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_483_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-blobulule-phase2'
        }
        FrameObject * single_instance_483_4_0; single_instance_483_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase2_212_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemygoo_213(parent->get_action_x() - parent->layer->off_x + 12, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_483_4_0 == NULL)
                    single_instance_483_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_483_4_0))->alterables->values.set(2, randrange_event(4)); // 'enemy-goo'
    }
    event_483_4_end: ;
}
void Frames::event_func_725()
{
    // event 484_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) >= (7))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_movement()->get_speed()) <= (5))) { it.deselect(); continue; }
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) < (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_484_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-blobulule-phase2'
        }
        FrameObject * single_instance_484_4_0; single_instance_484_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase2_212_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemygoo_213(parent->get_action_x() - parent->layer->off_x + -12, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_484_4_0 == NULL)
                    single_instance_484_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_484_4_0))->alterables->values.set(2, randrange_event(4)); // 'enemy-goo'
    }
    event_484_4_end: ;
}
void Frames::event_func_726()
{
    // event 485_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) < (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_485_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->alterables->values.get(2)*-1); // 'enemy-blobulule-phase2'
            ((Active*)*it)->alterables->values.add(0, 2); // 'enemy-blobulule-phase2'
        }
    }
    event_485_4_end: ;
}
void Frames::event_func_727()
{
    // event 486_4
    {
        // group: Blobulule
        screen_148_instances.clear_selection();
        if (!check_not_overlap(screen_148_instances, enemygoo_213_instances)) goto event_486_4_end;
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_486_4_end: ;
}
void Frames::event_func_728()
{
    // event 487_4
    {
        // group: Blobulule
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
        }
        if (!enemygoo_213_instances.has_selection()) goto event_487_4_end;
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_487_4_end: ;
}
void Frames::event_func_729()
{
    // event 488_4
    {
        // group: Blobulule
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!enemygoo_213_instances.has_selection()) goto event_488_4_end;
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_488_4_end: ;
}
void Frames::event_func_730()
{
    // event 489_4
    {
        // group: Blobulule
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!enemygoo_213_instances.has_selection()) goto event_489_4_end;
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(13);
        }
    }
    event_489_4_end: ;
}
void Frames::event_func_731()
{
    // event 490_4
    {
        // group: Blobulule
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (2))) { it.deselect(); continue; }
        }
        if (!enemygoo_213_instances.has_selection()) goto event_490_4_end;
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(14);
        }
    }
    event_490_4_end: ;
}
void Frames::event_func_732()
{
    // event 491_4
    {
        // group: Blobulule
        enemygoo_213_instances.clear_selection();
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (3))) { it.deselect(); continue; }
        }
        if (!enemygoo_213_instances.has_selection()) goto event_491_4_end;
        for (ObjectIterator it(enemygoo_213_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(15);
        }
    }
    event_491_4_end: ;
}
void Frames::event_func_733()
{
    // event 492_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_492_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(0);
        }
    }
    event_492_4_end: ;
}
void Frames::event_func_734()
{
    // event 493_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) < (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_493_4_end;
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
        }
    }
    event_493_4_end: ;
}
void Frames::event_func_735()
{
    // event 495_4
    {
        // group: Blobulule
        enemyblobululephase1_211_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase1_211_instances.has_selection()) goto event_495_4_end;
        for (ObjectIterator it(enemyblobululephase1_211_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemyblobululephase1_211_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemyblobululephase1_211_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_495_4_0; single_instance_495_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase1_211_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_495_4_0 == NULL)
                    single_instance_495_4_0 = new_obj;
            }
        }
        {
            loop_debris_running = true;
            int times = int(5);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_495_4_end: ;
}
void Frames::event_func_736()
{
    // event 497_4
    {
        // group: Blobulule
        enemyblobululephase2_212_instances.clear_selection();
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemyblobululephase2_212_instances.has_selection()) goto event_497_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemyblobululephase2_212_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemyblobululephase2_212_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        for (ObjectIterator it(enemyblobululephase2_212_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_497_4_0; single_instance_497_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyblobululephase2_212_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_497_4_0 == NULL)
                    single_instance_497_4_0 = new_obj;
            }
        }
        {
            loop_debris_running = true;
            int times = int(5);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_497_4_end: ;
}
void Frames::event_func_737()
{
    // event 503_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->get_x()+((Active*)*it)->alterables->values.get(2));
            ((Active*)*it)->set_y(((Active*)*it)->get_y()+((Active*)*it)->alterables->values.get(3));
        }
    }
    event_503_4_end: ;
}
void Frames::event_func_738()
{
    // event 505_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(16777472))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(3)) == (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_505_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) > (((Active*)get_single(enemymobilebrohoriz_214_instances, default_active_instance))->get_x()))) goto event_505_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 2); // 'enemy-mobilebrohoriz'
        }
    }
    event_505_4_end: ;
}
void Frames::event_func_739()
{
    // event 506_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(16777472))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(3)) == (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_506_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) < (((Active*)get_single(enemymobilebrohoriz_214_instances, default_active_instance))->get_x()))) goto event_506_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, -2); // 'enemy-mobilebrohoriz'
        }
    }
    event_506_4_end: ;
}
void Frames::event_func_740()
{
    // event 511_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(16777216))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-20))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()-4))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(5)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_511_4_end;
        if (not_always_511_4_0 > loop_count) {
            not_always_511_4_0 = loop_count + 2;
            goto event_511_4_end;
        }
        not_always_511_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 35); // 'enemy-mobilebrohoriz'
        }
        FrameObject * single_instance_511_4_1; single_instance_511_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemymobilebrohoriz_214_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_511_4_1 == NULL)
                    single_instance_511_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_511_4_1))->set_direction(8);
        ((Active*)((Active*)single_instance_511_4_1))->get_movement()->set_speed(100);
    }
    event_511_4_end: ;
}
void Frames::event_func_741()
{
    // event 512_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(256))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-20))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()-4))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(5)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_512_4_end;
        if (not_always_512_4_0 > loop_count) {
            not_always_512_4_0 = loop_count + 2;
            goto event_512_4_end;
        }
        not_always_512_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 35); // 'enemy-mobilebrohoriz'
        }
        FrameObject * single_instance_512_4_1; single_instance_512_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemymobilebrohoriz_214_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_512_4_1 == NULL)
                    single_instance_512_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_512_4_1))->set_direction(24);
        ((Active*)((Active*)single_instance_512_4_1))->get_movement()->set_speed(100);
    }
    event_512_4_end: ;
}
void Frames::event_func_742()
{
    // event 513_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(65536))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) > (((Active*)get_instance(player_93_instances))->get_y()-20))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) < (((Active*)get_instance(player_93_instances))->get_y()+4))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(5)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_513_4_end;
        if (not_always_513_4_0 > loop_count) {
            not_always_513_4_0 = loop_count + 2;
            goto event_513_4_end;
        }
        not_always_513_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 35); // 'enemy-mobilebrohoriz'
        }
        FrameObject * single_instance_513_4_1; single_instance_513_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemymobilebrohoriz_214_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_513_4_1 == NULL)
                    single_instance_513_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_513_4_1))->set_direction(0);
        ((Active*)((Active*)single_instance_513_4_1))->get_movement()->set_speed(100);
    }
    event_513_4_end: ;
}
void Frames::event_func_743()
{
    // event 514_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(1))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) > (((Active*)get_instance(player_93_instances))->get_y()-20))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) < (((Active*)get_instance(player_93_instances))->get_y()-4))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(5)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_514_4_end;
        if (not_always_514_4_0 > loop_count) {
            not_always_514_4_0 = loop_count + 2;
            goto event_514_4_end;
        }
        not_always_514_4_0 = loop_count + 2;
        media.stop_sample(SOUND_ZAP_17);
        media.set_sample_volume(SOUND_ZAP_17, global_values->get(12)*0.1);
        media.play_id(SOUND_ZAP_17, -1, 1);
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 35); // 'enemy-mobilebrohoriz'
        }
        FrameObject * single_instance_514_4_1; single_instance_514_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemymobilebrohoriz_214_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemylaser_202(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_514_4_1 == NULL)
                    single_instance_514_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_514_4_1))->set_direction(16);
        ((Active*)((Active*)single_instance_514_4_1))->get_movement()->set_speed(100);
    }
    event_514_4_end: ;
}
void Frames::event_func_744()
{
    // event 515_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_directions(65537))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(3)) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_515_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(3, 2); // 'enemy-mobilebrohoriz'
        }
    }
    event_515_4_end: ;
}
void Frames::event_func_745()
{
    // event 516_4
    {
        // group: MobileBro
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_516_4_end;
        hurtbox_174_instances.clear_selection();
        enemymobilebrohoriz_214_instances.clear_selection();
        if (!check_overlap(hurtbox_174_instances, enemymobilebrohoriz_214_instances)) goto event_516_4_end;
        global_values->sub(0, ((Active*)get_single(enemymobilebrohoriz_214_instances, default_active_instance))->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
        enemyzapball_185_instances.clear_selection();
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_516_4_end: ;
}
void Frames::event_func_746()
{
    // event 518_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_518_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_518_4_0; single_instance_518_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemymobilebrohoriz_214_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_518_4_0 == NULL)
                    single_instance_518_4_0 = new_obj;
            }
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemymobilebrohoriz_214_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemymobilebrohoriz_214_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 18); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 16); // 'camera shaker'
    }
    event_518_4_end: ;
}
void Frames::event_func_747()
{
    // event 520_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) > (0))) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_520_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'enemy-mobilebrohoriz'
        }
    }
    event_520_4_end: ;
}
void Frames::event_func_748()
{
    // event 521_4
    {
        // group: MobileBro
        enemymobilebrohoriz_214_instances.clear_selection();
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!enemymobilebrohoriz_214_instances.has_selection()) goto event_521_4_end;
        for (ObjectIterator it(enemymobilebrohoriz_214_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_521_4_end: ;
}
void Frames::event_func_749()
{
    // event 524_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
    }
    event_524_4_end: ;
}
void Frames::event_func_750()
{
    // event 526_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_526_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemydangerned_217_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemydangerned_217_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_526_4_0; single_instance_526_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_526_4_0 == NULL)
                    single_instance_526_4_0 = new_obj;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_526_4_1; single_instance_526_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_526_4_1 == NULL)
                    single_instance_526_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_526_4_1))->set_direction(8);
        ((Active*)((Active*)single_instance_526_4_1))->get_movement()->set_speed(15);
    }
    event_526_4_end: ;
}
void Frames::event_func_751()
{
    // event 527_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_527_4_end;
        FrameObject * single_instance_527_4_0; single_instance_527_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_527_4_0 == NULL)
                    single_instance_527_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_527_4_0))->set_direction(4);
        ((Active*)((Active*)single_instance_527_4_0))->get_movement()->set_speed(15);
    }
    event_527_4_end: ;
}
void Frames::event_func_752()
{
    // event 528_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_528_4_end;
        FrameObject * single_instance_528_4_0; single_instance_528_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_528_4_0 == NULL)
                    single_instance_528_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_528_4_0))->set_direction(0);
        ((Active*)((Active*)single_instance_528_4_0))->get_movement()->set_speed(15);
    }
    event_528_4_end: ;
}
void Frames::event_func_753()
{
    // event 529_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_529_4_end;
        FrameObject * single_instance_529_4_0; single_instance_529_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_529_4_0 == NULL)
                    single_instance_529_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_529_4_0))->set_direction(28);
        ((Active*)((Active*)single_instance_529_4_0))->get_movement()->set_speed(15);
    }
    event_529_4_end: ;
}
void Frames::event_func_754()
{
    // event 530_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_530_4_end;
        FrameObject * single_instance_530_4_0; single_instance_530_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_530_4_0 == NULL)
                    single_instance_530_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_530_4_0))->set_direction(24);
        ((Active*)((Active*)single_instance_530_4_0))->get_movement()->set_speed(15);
    }
    event_530_4_end: ;
}
void Frames::event_func_755()
{
    // event 531_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_531_4_end;
        FrameObject * single_instance_531_4_0; single_instance_531_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_531_4_0 == NULL)
                    single_instance_531_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_531_4_0))->set_direction(20);
        ((Active*)((Active*)single_instance_531_4_0))->get_movement()->set_speed(15);
    }
    event_531_4_end: ;
}
void Frames::event_func_756()
{
    // event 532_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_532_4_end;
        FrameObject * single_instance_532_4_0; single_instance_532_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_532_4_0 == NULL)
                    single_instance_532_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_532_4_0))->set_direction(16);
        ((Active*)((Active*)single_instance_532_4_0))->get_movement()->set_speed(15);
    }
    event_532_4_end: ;
}
void Frames::event_func_757()
{
    // event 533_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydangerned_217_instances.has_selection()) goto event_533_4_end;
        FrameObject * single_instance_533_4_0; single_instance_533_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydangerned_217_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_533_4_0 == NULL)
                    single_instance_533_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_533_4_0))->set_direction(12);
        ((Active*)((Active*)single_instance_533_4_0))->get_movement()->set_speed(15);
    }
    event_533_4_end: ;
}
void Frames::event_func_758()
{
    // event 536_4
    {
        // group: Dangerned
        enemydangerned_217_instances.clear_selection();
        active2_150_instances.clear_selection();
        if (!check_overlap(enemydangerned_217_instances, active2_150_instances)) goto event_536_4_end;
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
        for (ObjectIterator it(enemydangerned_217_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(1, 1); // 'enemy-dangerned'
            ((Active*)*it)->force_animation(13);
        }
    }
    event_536_4_end: ;
}
void Frames::event_func_759()
{
    // event 537_4
    {
        // group: Dangerned
        active2_150_instances.clear_selection();
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(4, 1); // 'Active 2'
        }
    }
    event_537_4_end: ;
}
void Frames::event_func_760()
{
    // event 538_4
    {
        // group: Dangerned
        active2_150_instances.clear_selection();
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) <= (0))) { it.deselect(); continue; }
        }
        if (!active2_150_instances.has_selection()) goto event_538_4_end;
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_538_4_end: ;
}
void Frames::event_func_761()
{
    // event 540_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) > (-2))) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_540_4_end;
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(1, 1); // 'enemy-zappa'
        }
    }
    event_540_4_end: ;
}
void Frames::event_func_762()
{
    // event 541_4
    {
        // group: Zappa
        every_541_4_0 += manager.dt;
        if (every_541_4_0 < 0.02) goto event_541_4_end;
        every_541_4_0 -= 0.02;
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->get_x()*1.0+(((Active*)*it)->alterables->values.get(1)*0.7));
        }
    }
    event_541_4_end: ;
}
void Frames::event_func_763()
{
    // event 543_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(2, 1); // 'enemy-zappa'
        }
    }
    event_543_4_end: ;
}
void Frames::event_func_764()
{
    // event 544_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) > (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(0)) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_544_4_end;
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_544_4_end: ;
}
void Frames::event_func_765()
{
    // event 545_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_545_4_end;
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_545_4_end: ;
}
void Frames::event_func_766()
{
    // event 546_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (-43))) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_546_4_end;
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->alterables->values.get(3)); // 'enemy-zappa'
        }
    }
    event_546_4_end: ;
}
void Frames::event_func_767()
{
    // event 548_4
    {
        // group: Zappa
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_animation(0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(2)) == (77))) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_548_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, enemyzappa_220_instances)) goto event_548_4_end;
        media.play_id(SOUND_QWASH_SHORT_15, -1, 1);
        media.set_sample_volume(SOUND_QWASH_SHORT_15, 0.2*global_values->get(12));
    }
    event_548_4_end: ;
}
void Frames::event_func_768()
{
    // event 549_4
    {
        // group: Zappa
        screen_148_instances.clear_selection();
        if (!check_not_overlap(screen_148_instances, enemyzappa_220_instances)) goto event_549_4_end;
        enemyzappa_220_instances.clear_selection();
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
        }
        if (!enemyzappa_220_instances.has_selection()) goto event_549_4_end;
        for (ObjectIterator it(enemyzappa_220_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_549_4_end: ;
}
void Frames::event_func_769()
{
    // event 550_4
    {
        // group: Drop Bro
        enemydroppo_222_instances.clear_selection();
        for (ObjectIterator it(enemydroppo_222_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+30))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-30))) { it.deselect(); continue; }
        }
        if (!enemydroppo_222_instances.has_selection()) goto event_550_4_end;
        if (not_always_550_4_0 > loop_count) {
            not_always_550_4_0 = loop_count + 2;
            goto event_550_4_end;
        }
        not_always_550_4_0 = loop_count + 2;
        FrameObject * single_instance_550_4_1; single_instance_550_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydroppo_222_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_dropposhot_223(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_550_4_1 == NULL)
                    single_instance_550_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_550_4_1))->get_movement()->set_speed(25);
        ((Active*)((Active*)single_instance_550_4_1))->set_direction(24);
    }
    event_550_4_end: ;
}
void Frames::event_func_770()
{
    // event 553_4
    {
        // group: Drop Bro
        dropposhot_223_instances.clear_selection();
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!dropposhot_223_instances.has_selection()) goto event_553_4_end;
        if (not_always_553_4_0 > loop_count) {
            not_always_553_4_0 = loop_count + 2;
            goto event_553_4_end;
        }
        not_always_553_4_0 = loop_count + 2;
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 2); // 'droppo-shot'
        }
        // select single: false false true
        SavedSelection extra_dropposhot_223_instances(dropposhot_223_instances);
        for (SavedIterator p_it(extra_dropposhot_223_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_dropposhot_223(parent->x + 0, parent->y + 0), parent->layer);
            }
        }
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(0);
        }
    }
    event_553_4_end: ;
}
void Frames::event_func_771()
{
    // event 554_4
    {
        // group: Drop Bro
        dropposhot_223_instances.clear_selection();
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!dropposhot_223_instances.has_selection()) goto event_554_4_end;
        if (not_always_554_4_0 > loop_count) {
            not_always_554_4_0 = loop_count + 2;
            goto event_554_4_end;
        }
        not_always_554_4_0 = loop_count + 2;
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 2); // 'droppo-shot'
        }
        // select single: false false true
        SavedSelection extra_dropposhot_223_instances(dropposhot_223_instances);
        for (SavedIterator p_it(extra_dropposhot_223_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_dropposhot_223(parent->x + 0, parent->y + 0), parent->layer);
            }
        }
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
        }
    }
    event_554_4_end: ;
}
void Frames::event_func_772()
{
    // event 556_4
    {
        // group: Drop Bro
        enemydroppo_222_instances.clear_selection();
        for (ObjectIterator it(enemydroppo_222_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemydroppo_222_instances.has_selection()) goto event_556_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemydroppo_222_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemydroppo_222_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_556_4_0; single_instance_556_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemydroppo_222_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_556_4_0 == NULL)
                    single_instance_556_4_0 = new_obj;
            }
        }
        for (ObjectIterator it(enemydroppo_222_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        {
            loop_debris_running = true;
            int times = int(8);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_556_4_end: ;
}
void Frames::event_func_773()
{
    // event 558_4
    {
        // group: Drop Bro
        dropposhot_223_instances.clear_selection();
        if (!check_not_overlap(dropposhot_223_instances, screen_148_instances)) goto event_558_4_end;
        for (ObjectIterator it(dropposhot_223_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_558_4_end: ;
}
void Frames::event_func_774()
{
    // event 560_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (0))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_560_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
    }
    event_560_4_end: ;
}
void Frames::event_func_775()
{
    // event 561_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-96))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+96))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) < (((Active*)get_instance(player_93_instances))->get_y()+96))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) > (((Active*)get_instance(player_93_instances))->get_y()-96))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_561_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 1); // 'enemy-rockiship'
        }
    }
    event_561_4_end: ;
}
void Frames::event_func_776()
{
    // event 562_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_562_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemyrockiship_227_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemyrockiship_227_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        FrameObject * single_instance_562_4_0; single_instance_562_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyrockiship_227_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_562_4_0 == NULL)
                    single_instance_562_4_0 = new_obj;
            }
        }
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        {
            loop_debris_running = true;
            int times = int(8);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_562_4_end: ;
}
void Frames::event_func_777()
{
    // event 566_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_566_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 1); // 'enemy-rockiship'
        }
    }
    event_566_4_end: ;
}
void Frames::event_func_778()
{
    // event 567_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_567_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-rockiship'
        }
    }
    event_567_4_end: ;
}
void Frames::event_func_779()
{
    // event 568_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (6))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_568_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(2, 0); // 'enemy-rockiship'
        }
    }
    event_568_4_end: ;
}
void Frames::event_func_780()
{
    // event 569_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        if (!check_not_overlap(enemyrockiship_227_instances, screen_148_instances)) goto event_569_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_569_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_569_4_end: ;
}
void Frames::event_func_781()
{
    // event 570_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_movement()->get_speed()) < (70))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_570_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->get_movement()->get_speed()+3);
        }
    }
    event_570_4_end: ;
}
void Frames::event_func_782()
{
    // event 571_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_571_4_end;
        if (not_always_571_4_0 > loop_count) {
            not_always_571_4_0 = loop_count + 2;
            goto event_571_4_end;
        }
        not_always_571_4_0 = loop_count + 2;
        media.set_sample_volume(SOUND_BOOM_16, 0.3*global_values->get(12));
        media.play_id(SOUND_BOOM_16, -1, 1);
    }
    event_571_4_end: ;
}
void Frames::event_func_783()
{
    // event 572_4
    {
        // group: Rock-It Ship
        enemyrockiship_227_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(enemyrockiship_227_instances, objeyeblock_169_instances)) goto event_572_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!enemyrockiship_227_instances.has_selection()) goto event_572_4_end;
        for (ObjectIterator it(enemyrockiship_227_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 6); // 'enemy-rockiship'
            ((Active*)*it)->alterables->values.set(2, 0); // 'enemy-rockiship'
        }
    }
    event_572_4_end: ;
}
void Frames::event_func_784()
{
    // event 577_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) < (3))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_577_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 1); // 'enemy-lonestar'
        }
    }
    event_577_4_end: ;
}
void Frames::event_func_785()
{
    // event 578_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) < (3))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_578_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 2); // 'enemy-lonestar'
        }
    }
    event_578_4_end: ;
}
void Frames::event_func_786()
{
    // event 580_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, get_abs(((Active*)*it)->get_x()-((Active*)*it)->alterables->values.get(2))); // 'enemy-lonestar'
        }
    }
    event_580_4_end: ;
}
void Frames::event_func_787()
{
    // event 581_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()+150))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) > (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_581_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(10);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.1);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
            ((Active*)*it)->set_direction(11);
        }
    }
    event_581_4_end: ;
}
void Frames::event_func_788()
{
    // event 582_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+150))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) > (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_582_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(9);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*0.97);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_582_4_end: ;
}
void Frames::event_func_789()
{
    // event 583_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_583_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(5)) == (0))) goto event_583_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) > (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_583_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(5);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.05);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_583_4_end: ;
}
void Frames::event_func_790()
{
    // event 584_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_584_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(5)) == (1))) goto event_584_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) > (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_584_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(11);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.05);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_584_4_end: ;
}
void Frames::event_func_791()
{
    // event 585_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()+150))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_585_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(6);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.1);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_585_4_end: ;
}
void Frames::event_func_792()
{
    // event 586_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+150))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_586_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(7);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*0.97);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_586_4_end: ;
}
void Frames::event_func_793()
{
    // event 587_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_587_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(5)) == (0))) goto event_587_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_587_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(11);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.05);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_587_4_end: ;
}
void Frames::event_func_794()
{
    // event 588_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+75))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_588_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(5)) == (1))) goto event_588_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) <= (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_588_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(5);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.05);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
        }
    }
    event_588_4_end: ;
}
void Frames::event_func_795()
{
    // event 589_4
    {
        // group: Lonestar Jr
        enemylonestar_233_instances.clear_selection();
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (((Active*)*it)->alterables->values.get(5)))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()-150))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(6)) > (20))) { it.deselect(); continue; }
        }
        if (!enemylonestar_233_instances.has_selection()) goto event_589_4_end;
        for (ObjectIterator it(enemylonestar_233_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(6);
            ((Active*)*it)->get_movement()->set_speed(((Active*)*it)->alterables->values.get(4)*1.1);
            ((Active*)*it)->alterables->values.set(3, 0); // 'enemy-lonestar'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-lonestar'
            ((Active*)*it)->set_direction(5);
        }
    }
    event_589_4_end: ;
}
