#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::event_func_177()
{
    // event 1019_4
    {
        // group: Crumble Block
        player_93_instances.clear_selection();
        objjunkblock_266_instances.clear_selection();
        if (!check_overlap(player_93_instances, objjunkblock_266_instances)) goto event_1019_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) < (0))) goto event_1019_4_end;
        for (ObjectIterator it(objjunkblock_266_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objjunkblock_266_instances.has_selection()) goto event_1019_4_end;
            loop_gravity_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()+1);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_1019_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_1019_4_0: ;
        }
    }
    event_1019_4_end: ;
}
void Frames::event_func_178()
{
    // event 1020_4
    {
        // group: Crumble Block
        player_93_instances.clear_selection();
        objjunkblock_266_instances.clear_selection();
        if (!check_overlap(player_93_instances, objjunkblock_266_instances)) goto event_1020_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) > (0))) goto event_1020_4_end;
        for (ObjectIterator it(objjunkblock_266_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objjunkblock_266_instances.has_selection()) goto event_1020_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_instance(player_93_instances))->get_y()-1);
        ((Active*)get_instance(player_93_instances))->alterables->values.set(0, 0); // 'Player'
            loop_gravity_running = false;
    
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_1020_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_1020_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(2, 0); // 'Player'
    }
    event_1020_4_end: ;
}
void Frames::loop_gravity_4()
{
    event_func_156();
    event_func_157();
    event_func_158();
    event_func_159();
    event_func_160();
    event_func_161();
    event_func_162();
    event_func_163();
    event_func_164();
    event_func_165();
    event_func_166();
    event_func_167();
    event_func_168();
    event_func_169();
    event_func_170();
    event_func_171();
    event_func_172();
    event_func_173();
    event_func_174();
    event_func_175();
    event_func_176();
    event_func_177();
    event_func_178();
}
void Frames::event_func_179()
{
    // event 727_4
    {
        // group: Newbox
        objnewcrate_274_instances.clear_selection();
        for (ObjectIterator it(objnewcrate_274_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
        }
        if (!objnewcrate_274_instances.has_selection()) goto event_727_4_end;
        for (ObjectIterator it(objnewcrate_274_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1);
        }
    }
    event_727_4_end: ;
}
void Frames::event_func_180()
{
    // event 728_4
    {
        // group: Newbox
        objnewcrate_274_instances.clear_selection();
        objcogblock_265_instances.clear_selection();
        if (!check_overlap(objnewcrate_274_instances, objcogblock_265_instances)) goto event_728_4_end;
        for (ObjectIterator it(objcogblock_265_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (1))) { it.deselect(); continue; }
        }
        if (!objcogblock_265_instances.has_selection()) goto event_728_4_end;
        for (ObjectIterator it(objnewcrate_274_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1);
        }
    }
    event_728_4_end: ;
}
void Frames::loop_newcrateinground_4()
{
    event_func_179();
    event_func_180();
}
void Frames::event_func_181()
{
    // event 333_4
    {
        // group: More collisions
        enemyhoppy_152_instances.clear_selection();
        objjunkblock_266_instances.clear_selection();
        if (!check_overlap(enemyhoppy_152_instances, objjunkblock_266_instances)) goto event_333_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1.0);
            ((Active*)*it)->alterables->values.set(4, 0); // 'Enemy-Hoppy'
            ((Active*)*it)->get_movement()->set_speed(0);
        }
    }
    event_333_4_end: ;
}
void Frames::loop_hoppyingarbage_4()
{
    event_func_181();
}
void Frames::event_func_182()
{
    // event 318_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_318_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1.0);
            ((Active*)*it)->alterables->values.set(4, 0); // 'Enemy-Hoppy'
            ((Active*)*it)->get_movement()->set_speed(0);
        }
    }
    event_318_4_end: ;
}
void Frames::loop_hoppyinground_4()
{
    event_func_182();
}
void Frames::event_func_183()
{
    // event 735_4
    {
        // group: Lonestar New
        enemylonestarnew_278_instances.clear_selection();
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
        }
        if (!enemylonestarnew_278_instances.has_selection()) goto event_735_4_end;
        for (ObjectIterator it(enemylonestarnew_278_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1);
            ((Active*)*it)->alterables->values.set(10, 0); // 'enemy-lonestarnew'
        }
    }
    event_735_4_end: ;
}
void Frames::loop_lonestaringround_4()
{
    event_func_183();
}
void Frames::event_func_184()
{
    // event 304_4
    {
        ((Active*)get_instance(healthbar_144_instances))->set_x_scale(global_values->get(0)/MathHelper()/100.0);
    }
    event_304_4_end: ;
}
void Frames::loop_healthupdate_4()
{
    event_func_184();
}
void Frames::event_func_185()
{
    // event 31_4
    {
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_31_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_31_4_0: ;
        }
        sprite_99_instances.clear_selection();
        for (ObjectIterator it(sprite_99_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)get_instance(player_93_instances))->get_x());
        }
        ((Active*)get_instance(hurtbox_174_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x());
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_31_4_1;
            ((Active*)get_instance(detectorbelow_267_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_31_4_1: ;
        }
    }
    event_31_4_end: ;
}
void Frames::event_func_186()
{
    // event 32_4
    {
        // group: Horizontal
        player_93_instances.clear_selection();
        door_103_instances.clear_selection();
        if (!check_overlap(player_93_instances, door_103_instances)) goto event_32_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(3)) > (0))) goto event_32_4_end;
        ((Active*)get_instance(player_93_instances))->alterables->values.sub(3, 1); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_32_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_32_4_0: ;
        }
        for (ObjectIterator it(door_103_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_32_4_1;
            ((Active*)get_instance(detectorbelow_267_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_32_4_1: ;
        }
        media.stop_sample(SOUND_FWOOSH_33);
        media.set_sample_volume(SOUND_FWOOSH_33, 0.7*global_values->get(12));
        media.play_id(SOUND_FWOOSH_33, -1, 1);
        media.set_sample_volume(SOUND_FWOOSH_33, 0.7*global_values->get(12));
    }
    event_32_4_end: ;
}
void Frames::event_func_187()
{
    // event 33_4
    {
        // group: Horizontal
        player_93_instances.clear_selection();
        door_103_instances.clear_selection();
        if (!check_overlap(player_93_instances, door_103_instances)) goto event_33_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_33_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_33_4_0: ;
        }
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_33_4_1;
            ((Active*)get_instance(detectorbelow_267_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_33_4_1: ;
        }
    }
    event_33_4_end: ;
}
void Frames::event_func_188()
{
    // event 34_4
    {
        // group: Horizontal
        if (!(((Active*)get_instance(player_93_instances))->overlaps_background())) goto event_34_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_34_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_34_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_34_4_1;
            ((Active*)get_instance(detectorbelow_267_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_34_4_1: ;
        }
    }
    event_34_4_end: ;
}
void Frames::event_func_189()
{
    // event 150_4
    {
        // group: Vert Platforms
        player_93_instances.clear_selection();
        vertplatform_106_instances.clear_selection();
        if (!check_overlap(player_93_instances, vertplatform_106_instances)) goto event_150_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_150_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_150_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_150_4_end: ;
}
void Frames::event_func_190()
{
    // event 270_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntstatic_131_instances)) goto event_270_4_end;
        if (!check_not_overlap(tntstatic_131_instances, conveyorl_100_instances)) goto event_270_4_end;
        if (!check_not_overlap(tntstatic_131_instances, conveyorr_101_instances)) goto event_270_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_270_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_270_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_270_4_end: ;
}
void Frames::event_func_191()
{
    // event 271_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntconveyor_139_instances)) goto event_271_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_271_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_271_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_271_4_end: ;
}
void Frames::event_func_192()
{
    // event 272_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntconveyor_139_instances)) goto event_272_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorl_100_instances)) goto event_272_4_end;
            loop_horiz_running = false;
    
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_272_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_272_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_272_4_end: ;
}
void Frames::event_func_193()
{
    // event 273_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntconveyor_139_instances)) goto event_273_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorr_101_instances)) goto event_273_4_end;
            loop_horiz_running = false;
    
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_273_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_273_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_273_4_end: ;
}
void Frames::event_func_194()
{
    // event 274_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntstatic_131_instances)) goto event_274_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorl_100_instances)) goto event_274_4_end;
            loop_horiz_running = false;
    
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_274_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_274_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_274_4_end: ;
}
void Frames::event_func_195()
{
    // event 275_4
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntstatic_131_instances)) goto event_275_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorr_101_instances)) goto event_275_4_end;
            loop_horiz_running = false;
    
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_275_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_275_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_275_4_end: ;
}
void Frames::event_func_196()
{
    // event 768_4
    {
        // group: Disappearing Blocks
        player_93_instances.clear_selection();
        dissappear_153_instances.clear_selection();
        if (!check_overlap(player_93_instances, dissappear_153_instances)) goto event_768_4_end;
        for (ObjectIterator it(dissappear_153_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!dissappear_153_instances.has_selection()) goto event_768_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_768_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_768_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_768_4_end: ;
}
void Frames::event_func_197()
{
    // event 793_4
    {
        // group: Eyeblock
        player_93_instances.clear_selection();
        objeyeblock_169_instances.clear_selection();
        if (!check_overlap(player_93_instances, objeyeblock_169_instances)) goto event_793_4_end;
        for (ObjectIterator it(objeyeblock_169_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objeyeblock_169_instances.has_selection()) goto event_793_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_793_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_793_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_793_4_end: ;
}
void Frames::event_func_198()
{
    // event 892_4
    {
        // group: Enemy Gates
        player_93_instances.clear_selection();
        objenemygate_235_instances.clear_selection();
        if (!check_overlap(player_93_instances, objenemygate_235_instances)) goto event_892_4_end;
        for (ObjectIterator it(objenemygate_235_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(2)) == (0))) { it.deselect(); continue; }
        }
        if (!objenemygate_235_instances.has_selection()) goto event_892_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_892_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_892_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_892_4_end: ;
}
void Frames::event_func_199()
{
    // event 999_4
    {
        // group: Clockwork Block
        player_93_instances.clear_selection();
        objcogblock_265_instances.clear_selection();
        if (!check_overlap(player_93_instances, objcogblock_265_instances)) goto event_999_4_end;
        for (ObjectIterator it(objcogblock_265_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objcogblock_265_instances.has_selection()) goto event_999_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_999_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_999_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_999_4_end: ;
}
void Frames::event_func_200()
{
    // event 1021_4
    {
        // group: Crumble Block
        player_93_instances.clear_selection();
        objjunkblock_266_instances.clear_selection();
        if (!check_overlap(player_93_instances, objjunkblock_266_instances)) goto event_1021_4_end;
        for (ObjectIterator it(objjunkblock_266_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->alterables->flags.is_off(0))) { it.deselect(); continue; }
        }
        if (!objjunkblock_266_instances.has_selection()) goto event_1021_4_end;
            loop_horiz_running = false;
    
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+(0-((Active*)get_instance(player_93_instances))->alterables->values.get(1)/MathHelper()/get_abs(((Active*)get_instance(player_93_instances))->alterables->values.get(1))));
        ((Active*)get_instance(player_93_instances))->alterables->values.set(1, 0); // 'Player'
        {
            FrameObject * parent = ((Active*)get_instance(player_93_instances));
            if (parent == NULL) goto pos_end_1021_4_0;
            ((Active*)get_instance(detector_94_instances))->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_1021_4_0: ;
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
    }
    event_1021_4_end: ;
}
void Frames::loop_horiz_4()
{
    event_func_185();
    event_func_186();
    event_func_187();
    event_func_188();
    event_func_189();
    event_func_190();
    event_func_191();
    event_func_192();
    event_func_193();
    event_func_194();
    event_func_195();
    event_func_196();
    event_func_197();
    event_func_198();
    event_func_199();
    event_func_200();
}
void Frames::event_func_201()
{
    // event 678_4
    {
        // group: Boxman
        enemyboxman_262_instances.clear_selection();
        for (ObjectIterator it(enemyboxman_262_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
        }
        if (!enemyboxman_262_instances.has_selection()) goto event_678_4_end;
        for (ObjectIterator it(enemyboxman_262_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1);
            ((Active*)*it)->alterables->values.set(0, 0); // 'enemy-boxman'
        }
    }
    event_678_4_end: ;
}
void Frames::event_func_202()
{
    // event 697_4
    {
        // group: Cog blocks
        enemyboxman_262_instances.clear_selection();
        objcogblock_265_instances.clear_selection();
        if (!check_overlap(enemyboxman_262_instances, objcogblock_265_instances)) goto event_697_4_end;
        for (ObjectIterator it(enemyboxman_262_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->get_y()-1);
            ((Active*)*it)->alterables->values.set(0, 0); // 'enemy-boxman'
        }
    }
    event_697_4_end: ;
}
void Frames::loop_boxmaninground_4()
{
    event_func_201();
    event_func_202();
}
void Frames::event_func_203()
{
    // event 463_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(1, ((Active*)get_instance(bullet_121_instances, default_active_instance))->alterables->values.get(4)); // 'enemy-floater'
        ((Active*)((Active*)col_instance_1))->force_animation(12);
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
    }
    event_463_4_end: ;
}
void Frames::event_func_204()
{
    // event 464_4
    {
        enemyatom_176_instances.clear_selection();
        for (ObjectIterator it(enemyatom_176_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_464_4_0; single_instance_464_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyatom_176_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_bigexplosion_177(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_464_4_0 == NULL)
                    single_instance_464_4_0 = new_obj;
            }
        }
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        framedatastore_183_instances.clear_selection();
        for (ObjectIterator it(framedatastore_183_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, ((Active*)get_single(enemyatom_176_instances, it.current_index, default_active_instance))->get_x()); // 'FrameDataStore'
            ((Active*)*it)->alterables->values.set(1, ((Active*)get_single(enemyatom_176_instances, it.current_index, default_active_instance))->get_y()); // 'FrameDataStore'
        }
        {
            loop_debris_running = true;
            int times = int(5);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_464_4_end: ;
}
void Frames::event_func_205()
{
    // event 465_4
    {
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(1, ((Active*)get_instance(bullet_121_instances, it.current_index, default_active_instance))->alterables->values.get(4)); // 'Enemy-Hoppy'
            ((Active*)*it)->force_animation(12);
        }
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
    }
    event_465_4_end: ;
}
void Frames::col_0_4()
{
    event_func_203();
    event_func_204();
    event_func_205();
}
void Frames::event_func_206()
{
    // event 372_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'enemy-floater'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
    }
    event_372_4_end: ;
}
void Frames::col_1_4()
{
    event_func_206();
}
void Frames::event_func_207()
{
    // event 194_4
    {
        // group: Sounds
        if (!((((Active*)col_instance_2)->alterables->values.get(2)) == (1))) goto event_194_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(0)) >= (0))) goto event_194_4_end;
        if (!((((Active*)col_instance_1)->alterables->values.get(3)) < (3))) goto event_194_4_end;
        if (not_always_194_4_0 > loop_count) {
            not_always_194_4_0 = loop_count + 2;
            goto event_194_4_end;
        }
        not_always_194_4_0 = loop_count + 2;
        media.stop_sample(SOUND_GETONGROUND_2);
        media.play_id(SOUND_GETONGROUND_2, -1, 1);
        media.set_sample_volume(SOUND_GETONGROUND_2, global_values->get(12)*0.4);
    }
    event_194_4_end: ;
}
void Frames::col_2_4()
{
    event_func_207();
}
void Frames::event_func_208()
{
    // event 967_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        global_values->sub(10, -1);
        FrameObject * single_instance_967_4_0; single_instance_967_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_explosion_130(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_967_4_0 == NULL)
                single_instance_967_4_0 = new_obj;
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)col_instance_2)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)col_instance_2)->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(15);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_967_4_end: ;
}
void Frames::col_3_4()
{
    event_func_208();
}
void Frames::event_func_209()
{
    // event 367_4
    {
        // group: Spike Shooter Test Enemy
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_367_4_end;
        global_values->sub(0, 15);
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_367_4_end: ;
}
void Frames::col_4_4()
{
    event_func_209();
}
void Frames::event_func_210()
{
    // event 563_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.set(0, 1); // 'enemy-rockiship'
        ((Active*)((Active*)col_instance_1))->destroy();
    }
    event_563_4_end: ;
}
void Frames::col_5_4()
{
    event_func_210();
}
void Frames::event_func_211()
{
    // event 264_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        FrameObject * single_instance_264_4_0; single_instance_264_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyexplosion_178(((Active*)col_instance_2)->x + 0, ((Active*)col_instance_2)->y + 0), ((Active*)col_instance_2)->layer);
            if (single_instance_264_4_0 == NULL)
                single_instance_264_4_0 = new_obj;
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 10); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 10); // 'camera shaker'
    }
    event_264_4_end: ;
}
void Frames::col_6_4()
{
    event_func_211();
}
void Frames::event_func_212()
{
    // event 864_4
    {
        {
            FrameObject * parent = ((Active*)col_instance_1);
            if (parent == NULL) goto pos_end_864_4_0;
            ((Active*)col_instance_2)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_864_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->set_direction(0);
    }
    event_864_4_end: ;
}
void Frames::col_7_4()
{
    event_func_212();
}
void Frames::event_func_213()
{
    // event 240_4
    {
        // group: Sounds
        screen_148_instances.clear_selection();
        if (!check_overlap(((Active*)col_instance_2), screen_148_instances)) goto event_240_4_end;
        media.set_sample_volume(SOUND_RICOCHET_27, 0.3*global_values->get(12));
        media.stop_sample(SOUND_RICOCHET_27);
        media.play_id(SOUND_RICOCHET_27, -1, 1);
        media.set_sample_volume(SOUND_RICOCHET_27, global_values->get(12)*0.3);
    }
    event_240_4_end: ;
}
void Frames::event_func_214()
{
    // event 871_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(254))) goto event_871_4_end;
        if (!(((Active*)col_instance_1)->test_directions(4026531855))) goto event_871_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_871_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_871_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(24);
    }
    event_871_4_end: ;
}
void Frames::event_func_215()
{
    // event 872_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(254))) goto event_872_4_end;
        if (!(((Active*)col_instance_1)->test_directions(4080))) goto event_872_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_872_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_872_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(16);
    }
    event_872_4_end: ;
}
void Frames::event_func_216()
{
    // event 873_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(4261412864))) goto event_873_4_end;
        if (!(((Active*)col_instance_1)->test_directions(4026531855))) goto event_873_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_873_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_873_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(8);
    }
    event_873_4_end: ;
}
void Frames::event_func_217()
{
    // event 874_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(4261412864))) goto event_874_4_end;
        if (!(((Active*)col_instance_1)->test_directions(267386880))) goto event_874_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_874_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_874_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(16);
    }
    event_874_4_end: ;
}
void Frames::event_func_218()
{
    // event 875_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(16646144))) goto event_875_4_end;
        if (!(((Active*)col_instance_1)->test_directions(1044480))) goto event_875_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_875_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_875_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(8);
    }
    event_875_4_end: ;
}
void Frames::event_func_219()
{
    // event 876_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(16646144))) goto event_876_4_end;
        if (!(((Active*)col_instance_1)->test_directions(267386880))) goto event_876_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_876_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_876_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(0);
    }
    event_876_4_end: ;
}
void Frames::event_func_220()
{
    // event 877_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(65024))) goto event_877_4_end;
        if (!(((Active*)col_instance_1)->test_directions(4080))) goto event_877_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_877_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_877_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(0);
    }
    event_877_4_end: ;
}
void Frames::event_func_221()
{
    // event 878_4
    {
        // group: Laser redirectors
        if (!(((Active*)col_instance_2)->test_directions(65024))) goto event_878_4_end;
        if (!(((Active*)col_instance_1)->test_directions(1044480))) goto event_878_4_end;
        {
            FrameObject * parent = ((Active*)col_instance_2);
            if (parent == NULL) goto pos_end_878_4_0;
            ((Active*)col_instance_1)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_878_4_0: ;
        }
        ((Active*)((Active*)col_instance_1))->set_direction(24);
    }
    event_878_4_end: ;
}
void Frames::col_8_4()
{
    event_func_213();
    event_func_214();
    event_func_215();
    event_func_216();
    event_func_217();
    event_func_218();
    event_func_219();
    event_func_220();
    event_func_221();
}
void Frames::event_func_222()
{
    // event 621_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
    }
    event_621_4_end: ;
}
void Frames::col_9_4()
{
    event_func_222();
}
void Frames::event_func_223()
{
    // event 455_4
    {
        // group: Walker
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_455_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_455_4_end: ;
}
void Frames::col_10_4()
{
    event_func_223();
}
void Frames::event_func_224()
{
    // event 931_4
    {
        ((Active*)((Active*)col_instance_1))->destroy();
    }
    event_931_4_end: ;
}
void Frames::col_11_4()
{
    event_func_224();
}
void Frames::event_func_225()
{
    // event 201_4
    {
        // group: Sounds
        if (not_always_201_4_0 > loop_count) {
            not_always_201_4_0 = loop_count + 2;
            goto event_201_4_end;
        }
        not_always_201_4_0 = loop_count + 2;
        media.play_id(SOUND_ENEMYHIT_3, 32-1);
        media.set_sample_volume(SOUND_ENEMYHIT_3, global_values->get(12)*0.45);
    }
    event_201_4_end: ;
}
void Frames::event_func_226()
{
    // event 420_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)col_instance_1)->alterables->values.get(4)); // 'enemy-chomper'
        ((Active*)((Active*)col_instance_2))->force_animation(13);
        ((Active*)((Active*)col_instance_2))->alterables->values.set(4, 0); // 'enemy-chomper'
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 6); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 5); // 'camera shaker'
    }
    event_420_4_end: ;
}
void Frames::col_12_4()
{
    event_func_225();
    event_func_226();
}
void Frames::event_func_227()
{
    // event 439_4
    {
        // group: BrokenBrain
        if (!((((Active*)col_instance_1)->alterables->values.get(4)) == (0))) goto event_439_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_439_4_end: ;
}
void Frames::col_13_4()
{
    event_func_227();
}
void Frames::event_func_228()
{
    // event 299_4
    {
        ((Active*)((Active*)col_instance_1))->get_movement()->bounce(Movement::COLLISION);
    }
    event_299_4_end: ;
}
void Frames::col_14_4()
{
    event_func_228();
}
void Frames::event_func_229()
{
    // event 863_4
    {
        {
            FrameObject * parent = ((Active*)col_instance_1);
            if (parent == NULL) goto pos_end_863_4_0;
            ((Active*)col_instance_2)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_863_4_0: ;
        }
        ((Active*)((Active*)col_instance_2))->set_direction(24);
    }
    event_863_4_end: ;
}
void Frames::col_15_4()
{
    event_func_229();
}
void Frames::event_func_230()
{
    // event 700_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(0, 1); // 'enemy-gearoflaw'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
    }
    event_700_4_end: ;
}
void Frames::col_16_4()
{
    event_func_225();
    event_func_230();
}
void Frames::event_func_231()
{
    // event 682_4
    {
        // group: Boxman
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_682_4_end;
        global_values->sub(0, ((Active*)col_instance_2)->alterables->values.get(2));
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_682_4_end: ;
}
void Frames::col_17_4()
{
    event_func_231();
}
void Frames::event_func_232()
{
    // event 881_4
    {
        ((Active*)((Active*)col_instance_1))->set_visible(false);
        ((Active*)((Active*)col_instance_2))->set_direction(24);
    }
    event_881_4_end: ;
}
void Frames::col_18_4()
{
    event_func_232();
}
void Frames::event_func_233()
{
    // event 159_4
    {
        manager.ignore_controls = true;
        {
            ((Active*)col_instance_1)->set_global_position(4144, 624);
            pos_end_159_4_0: ;
        }
        ((Active*)get_instance(inputcoordinatorsecretary_116_instances))->force_animation(1);
    }
    event_159_4_end: ;
}
void Frames::col_19_4()
{
    event_func_233();
}
void Frames::event_func_234()
{
    // event 463_4
    {
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(1, ((Active*)get_instance(bullet_121_instances, default_active_instance))->alterables->values.get(4)); // 'enemy-floater'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(5, 1); // 'Bullet'
        }
    }
    event_463_4_end: ;
}
void Frames::col_20_4()
{
    event_func_234();
    event_func_204();
    event_func_205();
}
void Frames::event_func_235()
{
    // event 576_4
    {
        ((Active*)((Active*)col_instance_2))->get_movement()->bounce(Movement::COLLISION);
        ((Active*)((Active*)col_instance_2))->get_movement()->set_speed(0);
    }
    event_576_4_end: ;
}
void Frames::col_21_4()
{
    event_func_235();
}
void Frames::event_func_236()
{
    // event 405_4
    {
        // group: Atom Bomb
        if (!((((Active*)col_instance_2)->alterables->values.get(3)) <= (0))) goto event_405_4_end;
        FrameObject * single_instance_405_4_0; single_instance_405_4_0 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_enemyatom_176(((Active*)col_instance_2)->x + 16, ((Active*)col_instance_2)->y + 16), ((Active*)col_instance_2)->layer);
            if (single_instance_405_4_0 == NULL)
                single_instance_405_4_0 = new_obj;
        }
        ((Active*)((Active*)single_instance_405_4_0))->alterables->values.set(7, ((Active*)get_instance(player_93_instances))->get_y()+(((Active*)single_instance_405_4_0)->alterables->values.get(0)/MathHelper()/2)-20); // 'enemy-atom'
        ((Active*)((Active*)col_instance_2))->alterables->values.set(3, 250); // 'SpawnerAtom'
    }
    event_405_4_end: ;
}
void Frames::col_22_4()
{
    event_func_236();
}
void Frames::event_func_237()
{
    // event 461_4
    {
        // group: Walker
        if (!((((Active*)col_instance_1)->alterables->values.get(2)) == (1))) goto event_461_4_end;
        ((Active*)((Active*)col_instance_2))->get_movement()->bounce(Movement::COLLISION);
        ((Active*)((Active*)col_instance_2))->get_movement()->set_speed(((Active*)col_instance_2)->get_movement()->get_speed()/MathHelper()/3);
    }
    event_461_4_end: ;
}
void Frames::col_24_4()
{
    event_func_237();
}
void Frames::event_func_238()
{
    // event 687_4
    {
        ((Active*)((Active*)col_instance_1))->alterables->values.sub(5, 1); // 'Bullet'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 7); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 7); // 'camera shaker'
        ((Active*)((Active*)col_instance_2))->alterables->values.sub(0, 1); // 'enemy-boxspawner'
        ((Active*)((Active*)col_instance_2))->force_animation(12);
    }
    event_687_4_end: ;
}
void Frames::col_25_4()
{
    event_func_225();
    event_func_238();
}
void Frames::event_func_239()
{
    // event 860_4
    {
        ((Active*)((Active*)col_instance_2))->set_direction(0);
        ((Active*)((Active*)col_instance_1))->set_visible(false);
    }
    event_860_4_end: ;
}
void Frames::col_26_4()
{
    event_func_239();
}
void Frames::event_func_240()
{
    // event 341_4
    {
        ((Active*)((Active*)col_instance_2))->destroy();
        ((Active*)((Active*)col_instance_1))->destroy();
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
        media.stop_sample(SOUND_IMPAKT_35);
        media.play_id(SOUND_IMPAKT_35, -1, 1);
        media.set_sample_volume(SOUND_IMPAKT_35, 0.25*global_values->get(12));
    }
    event_341_4_end: ;
}
void Frames::col_27_4()
{
    event_func_240();
}
void Frames::event_func_241()
{
    // event 234_4
    {
        media.play_id(SOUND_KEY_11, -1, 1);
        media.set_sample_volume(SOUND_KEY_11, global_values->get(12)*1.0);
    }
    event_234_4_end: ;
}
