#include "events.h"
#include "framedata.h"
#include "lists.h"
#include "media.h"
#include "objects.h"
#include "bitarray.h"

void Frames::event_func_596()
{
    // event 277_4
    {
        // group: Crates
        tntstatic_131_instances.clear_selection();
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorr_101_instances)) goto event_277_4_end;
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(0, 2); // 'TNT-static'
            ((Active*)*it)->get_movement()->set_speed(0);
        }
    }
    event_277_4_end: ;
}
void Frames::event_func_597()
{
    // event 278_4
    {
        // group: Crates
        tntconveyor_139_instances.clear_selection();
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorl_100_instances)) goto event_278_4_end;
        for (ObjectIterator it(tntconveyor_139_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 2); // 'TNT-conveyor'
            ((Active*)*it)->get_movement()->set_speed(0);
        }
    }
    event_278_4_end: ;
}
void Frames::event_func_598()
{
    // event 279_4
    {
        // group: Crates
        tntstatic_131_instances.clear_selection();
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorl_100_instances)) goto event_279_4_end;
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(0, 2); // 'TNT-static'
            ((Active*)*it)->get_movement()->set_speed(0);
        }
    }
    event_279_4_end: ;
}
void Frames::event_func_599()
{
    // event 282_4
    {
        // group: Crates
        every_282_4_0 += manager.dt;
        if (every_282_4_0 < 1.5) goto event_282_4_end;
        every_282_4_0 -= 1.5;
        screenfar_277_instances.clear_selection();
        pipe_138_instances.clear_selection();
        if (!check_overlap(screenfar_277_instances, pipe_138_instances)) goto event_282_4_end;
        FrameObject * single_instance_282_4_1; single_instance_282_4_1 = NULL;
        // select single: true false false
        {
            FrameObject * parent = ((Active*)get_instance(pipe_138_instances));
            {
                FrameObject * new_obj;
                new_obj = add_object(create_tntconveyor_139(parent->x + 0, parent->y + 16), parent->layer);
                if (single_instance_282_4_1 == NULL)
                    single_instance_282_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_282_4_1))->alterables->values.set(0, ((Active*)single_instance_282_4_1)->get_x()); // 'TNT-conveyor'
        tntstatic_131_instances.clear_selection();
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, ((Active*)*it)->get_x()); // 'TNT-static'
        }
    }
    event_282_4_end: ;
}
void Frames::event_func_600()
{
    // event 283_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntstatic_131_instances)) goto event_283_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorr_101_instances)) goto event_283_4_end;
        if (((Active*)get_instance(player_93_instances))->overlaps_background()) goto event_283_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_283_4_end: ;
}
void Frames::event_func_601()
{
    // event 284_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntstatic_131_instances)) goto event_284_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorl_100_instances)) goto event_284_4_end;
        if (((Active*)get_instance(player_93_instances))->overlaps_background()) goto event_284_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_284_4_end: ;
}
void Frames::event_func_602()
{
    // event 285_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntstatic_131_instances)) goto event_285_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorl_100_instances)) goto event_285_4_end;
        if (!(((Active*)get_instance(player_93_instances))->overlaps_background())) goto event_285_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_285_4_end: ;
}
void Frames::event_func_603()
{
    // event 286_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntstatic_131_instances)) goto event_286_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, conveyorr_101_instances)) goto event_286_4_end;
        if (!(((Active*)get_instance(player_93_instances))->overlaps_background())) goto event_286_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_286_4_end: ;
}
void Frames::event_func_604()
{
    // event 287_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntstatic_131_instances)) goto event_287_4_end;
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) > (0))) { it.deselect(); continue; }
        }
        if (!tntstatic_131_instances.has_selection()) goto event_287_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_single(tntstatic_131_instances, default_active_instance))->get_y()-36);
        ((Active*)get_instance(detector_94_instances))->set_y(((Active*)get_single(tntstatic_131_instances, default_active_instance))->get_y()-31);
    }
    event_287_4_end: ;
}
void Frames::event_func_605()
{
    // event 288_4
    bool or_result_288_4 = false;
    bool or_temp_result_288_4_0 = false;
    {
        // group: Crates
        player_93_instances.clear_selection();
        tntstatic_131_instances.clear_selection();
        if (!check_overlap(player_93_instances, tntstatic_131_instances)) goto or_event_288_4_0_end;
        or_result_288_4 = true;
        or_temp_result_288_4_0 = true;
    }
    or_event_288_4_0_end: ;
    tntstatic_131_instances.clear_saved_selection();
    player_93_instances.clear_saved_selection();
    if (or_temp_result_288_4_0) {
        tntstatic_131_instances.save_selection();
        player_93_instances.save_selection();
    }
    // event 288_4
    bool or_temp_result_288_4_1 = false;
    {
        // group: Crates
        tntstatic_131_instances.clear_selection();
        detector_94_instances.clear_selection();
        if (!check_overlap(tntstatic_131_instances, detector_94_instances)) goto or_event_288_4_1_end;
        or_result_288_4 = true;
        or_temp_result_288_4_1 = true;
        or_event_288_4_1_end: ;
        detector_94_instances.clear_saved_selection();
        if (or_temp_result_288_4_1) {
            tntstatic_131_instances.save_selection();
            detector_94_instances.save_selection();
        }
        if (!or_result_288_4) goto or_final_or_event_288_4_1_end;
        player_93_instances.empty_selection();
        detector_94_instances.empty_selection();
        tntstatic_131_instances.empty_selection();
        if (or_temp_result_288_4_0 || or_temp_result_288_4_1) {
            tntstatic_131_instances.restore_selection();
        }
        if (or_temp_result_288_4_1) {
            detector_94_instances.restore_selection();
        }
        if (or_temp_result_288_4_0) {
            player_93_instances.restore_selection();
        }
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    or_final_or_event_288_4_1_end: ;
}
void Frames::event_func_606()
{
    // event 289_4
    {
        // group: Crates
        tntstatic_131_instances.clear_selection();
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!tntstatic_131_instances.has_selection()) goto event_289_4_end;
        for (ObjectIterator it(tntstatic_131_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        FrameObject * single_instance_289_4_0; single_instance_289_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(tntstatic_131_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_289_4_0 == NULL)
                    single_instance_289_4_0 = new_obj;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 12); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 12); // 'camera shaker'
    }
    event_289_4_end: ;
}
void Frames::event_func_607()
{
    // event 291_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntconveyor_139_instances)) goto event_291_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorr_101_instances)) goto event_291_4_end;
        if (((Active*)get_instance(player_93_instances))->overlaps_background()) goto event_291_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_291_4_end: ;
}
void Frames::event_func_608()
{
    // event 292_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntconveyor_139_instances)) goto event_292_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorl_100_instances)) goto event_292_4_end;
        if (((Active*)get_instance(player_93_instances))->overlaps_background()) goto event_292_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_292_4_end: ;
}
void Frames::event_func_609()
{
    // event 293_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntconveyor_139_instances)) goto event_293_4_end;
        conveyorl_100_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorl_100_instances)) goto event_293_4_end;
        if (!(((Active*)get_instance(player_93_instances))->overlaps_background())) goto event_293_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()+2);
    }
    event_293_4_end: ;
}
void Frames::event_func_610()
{
    // event 294_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntconveyor_139_instances)) goto event_294_4_end;
        conveyorr_101_instances.clear_selection();
        if (!check_overlap(tntconveyor_139_instances, conveyorr_101_instances)) goto event_294_4_end;
        if (!(((Active*)get_instance(player_93_instances))->overlaps_background())) goto event_294_4_end;
        ((Active*)get_instance(player_93_instances))->set_x(((Active*)get_instance(player_93_instances))->get_x()-2);
    }
    event_294_4_end: ;
}
void Frames::event_func_611()
{
    // event 295_4
    {
        // group: Crates
        detector_94_instances.clear_selection();
        tntconveyor_139_instances.clear_selection();
        if (!check_overlap(detector_94_instances, tntconveyor_139_instances)) goto event_295_4_end;
        for (ObjectIterator it(tntconveyor_139_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) > (0))) { it.deselect(); continue; }
        }
        if (!tntconveyor_139_instances.has_selection()) goto event_295_4_end;
        ((Active*)get_instance(player_93_instances))->set_y(((Active*)get_single(tntconveyor_139_instances, default_active_instance))->get_y()-36);
        ((Active*)get_instance(detector_94_instances))->set_y(((Active*)get_single(tntconveyor_139_instances, default_active_instance))->get_y()-31);
    }
    event_295_4_end: ;
}
void Frames::event_func_612()
{
    // event 301_4
    {
        // group: Crates
        objtntspawner_238_instances.clear_selection();
        for (ObjectIterator it(objtntspawner_238_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) == (1))) { it.deselect(); continue; }
        }
        if (!objtntspawner_238_instances.has_selection()) goto event_301_4_end;
        for (ObjectIterator it(objtntspawner_238_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_301_4_end: ;
}
void Frames::event_func_613()
{
    // event 305_4
    {
        // group: Health/lives
        if (!((global_values->get(0)) > (100))) goto event_305_4_end;
        global_values->set(0, 100);
        {
            loop_healthupdate_running = true;
            int times = int(1);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
    }
    event_305_4_end: ;
}
void Frames::event_func_614()
{
    // event 310_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_310_4_end;
        FrameObject * single_instance_310_4_0; single_instance_310_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyhoppy_152_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_310_4_0 == NULL)
                    single_instance_310_4_0 = new_obj;
            }
        }
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemyhoppy_152_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemyhoppy_152_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(5);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 17); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 17); // 'camera shaker'
    }
    event_310_4_end: ;
}
void Frames::event_func_615()
{
    // event 311_4
    {
        // group: Hoppy Enemy
        every_311_4_0 += manager.dt;
        if (every_311_4_0 < 0.01) goto event_311_4_end;
        every_311_4_0 -= 0.01;
        spawnerhoppy_151_instances.clear_selection();
        for (ObjectIterator it(spawnerhoppy_151_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) > (0))) { it.deselect(); continue; }
        }
        if (!spawnerhoppy_151_instances.has_selection()) goto event_311_4_end;
        for (ObjectIterator it(spawnerhoppy_151_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(3, 1); // 'SpawnerHoppy'
        }
    }
    event_311_4_end: ;
}
void Frames::event_func_616()
{
    // event 313_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) == (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_313_4_end;
        if (!check_not_overlap(enemyhoppy_152_instances, objjunkblock_266_instances)) goto event_313_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, get_ceil(((Active*)*it)->alterables->values.get(6)*-1.0*0.4)+0.2); // 'Enemy-Hoppy'
            ((Active*)*it)->get_movement()->set_speed((((Active*)*it)->alterables->values.get(7)/MathHelper()/2.0)-5.0);
        }
    }
    event_313_4_end: ;
}
void Frames::event_func_617()
{
    // event 314_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) != (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_314_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, ((Active*)*it)->alterables->values.get(4)); // 'Enemy-Hoppy'
            ((Active*)*it)->alterables->values.set(7, ((Active*)*it)->get_movement()->get_speed()); // 'Enemy-Hoppy'
        }
    }
    event_314_4_end: ;
}
void Frames::event_func_618()
{
    // event 316_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_316_4_end;
        if (!check_not_overlap(enemyhoppy_152_instances, objjunkblock_266_instances)) goto event_316_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(4, 0.2); // 'Enemy-Hoppy'
            ((Active*)*it)->set_y((((Active*)*it)->get_y()*1.0)+(((Active*)*it)->alterables->values.get(4)*1.0));
        }
    }
    event_316_4_end: ;
}
void Frames::event_func_619()
{
    // event 317_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->overlaps_background())) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_317_4_end;
        {
            loop_hoppyinground_running = true;
            int times = int(5);
            loop_hoppyinground_index = 0;
            while (loop_hoppyinground_index < times) {
                loop_hoppyinground_4();
                if (!loop_hoppyinground_running) break;
                loop_hoppyinground_index++;
            }
        }
    }
    event_317_4_end: ;
}
void Frames::event_func_620()
{
    // event 319_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (((Active*)(*it))->overlaps_background()) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_319_4_end;
        if (!(false)) goto event_319_4_end;
            loop_hoppyinground_running = false;
    
    }
    event_319_4_end: ;
}
void Frames::event_func_621()
{
    // event 320_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) == (0))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->alterables->values.get(4)) <= (1))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_320_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 1); // 'Enemy-Hoppy'
        }
    }
    event_320_4_end: ;
}
void Frames::event_func_622()
{
    // event 321_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) >= (44))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_321_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(3, 0); // 'Enemy-Hoppy'
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
            ((Active*)*it)->get_movement()->set_speed(((get_abs(((Active*)*it)->get_x()-((Active*)get_instance(player_93_instances))->get_x())/MathHelper()/320.0)*43.0)+5.0);
            ((Active*)*it)->alterables->values.sub(4, 5.0); // 'Enemy-Hoppy'
            ((Active*)*it)->alterables->values.set(4, (-1.0*((get_abs(((Active*)*it)->get_x()-((Active*)get_instance(player_93_instances))->get_x())/MathHelper()/320.0))*5.0)-3.0); // 'Enemy-Hoppy'
        }
        FrameObject * single_instance_321_4_0; single_instance_321_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyhoppy_152_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_objgarbagedestroyer_280(parent->x + 0, parent->y + 1), parent->layer);
                if (single_instance_321_4_0 == NULL)
                    single_instance_321_4_0 = new_obj;
            }
        }
    }
    event_321_4_end: ;
}
void Frames::event_func_623()
{
    // event 322_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) >= (23))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_322_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->get_movement()->set_speed(23);
        }
    }
    event_322_4_end: ;
}
void Frames::event_func_624()
{
    // event 323_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) < (-5))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_323_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, -5.0); // 'Enemy-Hoppy'
        }
    }
    event_323_4_end: ;
}
void Frames::event_func_625()
{
    // event 324_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) == (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_324_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(0);
        }
    }
    event_324_4_end: ;
}
void Frames::event_func_626()
{
    // event 325_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_movement()->get_speed()) != (0))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_325_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(7);
        }
    }
    event_325_4_end: ;
}
void Frames::event_func_627()
{
    // event 326_4
    {
        // group: Hoppy Enemy
        enemyspawnerhoppy_279_instances.clear_selection();
        for (ObjectIterator it(enemyspawnerhoppy_279_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) >= (200))) { it.deselect(); continue; }
        }
        if (!enemyspawnerhoppy_279_instances.has_selection()) goto event_326_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(screen_148_instances, enemyspawnerhoppy_279_instances)) goto event_326_4_end;
        if (not_always_326_4_0 > loop_count) {
            not_always_326_4_0 = loop_count + 2;
            goto event_326_4_end;
        }
        not_always_326_4_0 = loop_count + 2;
        FrameObject * single_instance_326_4_1; single_instance_326_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyspawnerhoppy_279_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyhoppy_152(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_326_4_1 == NULL)
                    single_instance_326_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_326_4_1))->alterables->values.set(3, 44); // 'Enemy-Hoppy'
        ((Active*)((Active*)single_instance_326_4_1))->alterables->values.set(3, 44); // 'Enemy-Hoppy'
        ((Active*)((Active*)single_instance_326_4_1))->alterables->values.set(3, 44); // 'Enemy-Hoppy'
        for (ObjectIterator it(enemyspawnerhoppy_279_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(1);
        }
    }
    event_326_4_end: ;
}
void Frames::event_func_628()
{
    // event 328_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        if (!check_not_overlap(enemyhoppy_152_instances, screen_148_instances)) goto event_328_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(5, 1); // 'Enemy-Hoppy'
        }
    }
    event_328_4_end: ;
}
void Frames::event_func_629()
{
    // event 329_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        screen_148_instances.clear_selection();
        if (!check_overlap(enemyhoppy_152_instances, screen_148_instances)) goto event_329_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 0); // 'Enemy-Hoppy'
        }
    }
    event_329_4_end: ;
}
void Frames::event_func_630()
{
    // event 330_4
    {
        // group: Hoppy Enemy
        enemyhoppy_152_instances.clear_selection();
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) > (100))) { it.deselect(); continue; }
        }
        if (!enemyhoppy_152_instances.has_selection()) goto event_330_4_end;
        for (ObjectIterator it(enemyhoppy_152_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_330_4_end: ;
}
void Frames::event_func_631()
{
    // event 332_4
    {
        // group: More collisions
        enemyhoppy_152_instances.clear_selection();
        objjunkblock_266_instances.clear_selection();
        if (!check_overlap(enemyhoppy_152_instances, objjunkblock_266_instances)) goto event_332_4_end;
        {
            loop_hoppyingarbage_running = true;
            int times = int(5);
            loop_hoppyingarbage_index = 0;
            while (loop_hoppyingarbage_index < times) {
                loop_hoppyingarbage_4();
                if (!loop_hoppyingarbage_running) break;
                loop_hoppyingarbage_index++;
            }
        }
    }
    event_332_4_end: ;
}
void Frames::event_func_632()
{
    // event 334_4
    {
        // group: More collisions
        enemyhoppy_152_instances.clear_selection();
        if (!check_not_overlap(enemyhoppy_152_instances, objjunkblock_266_instances)) goto event_334_4_end;
        if (!(false)) goto event_334_4_end;
            loop_hoppyingarbage_running = false;
    
    }
    event_334_4_end: ;
}
void Frames::event_func_633()
{
    // event 336_4
    {
        // group: More collisions
        objgarbagedestroyer_280_instances.clear_selection();
        for (ObjectIterator it(objgarbagedestroyer_280_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 0)) { it.deselect(); continue; }
        }
        if (!objgarbagedestroyer_280_instances.has_selection()) goto event_336_4_end;
        for (ObjectIterator it(objgarbagedestroyer_280_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_336_4_end: ;
}
void Frames::event_func_634()
{
    // event 348_4
    {
        // group: More collisions
        objgarbagedestroyer_280_instances.clear_selection();
        for (ObjectIterator it(objgarbagedestroyer_280_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(0, 1); // 'obj-garbagedestroyer'
        }
    }
    event_348_4_end: ;
}
void Frames::event_func_635()
{
    // event 349_4
    {
        // group: More collisions
        objgarbagedestroyer_280_instances.clear_selection();
        for (ObjectIterator it(objgarbagedestroyer_280_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(0)) >= (10))) { it.deselect(); continue; }
        }
        if (!objgarbagedestroyer_280_instances.has_selection()) goto event_349_4_end;
        for (ObjectIterator it(objgarbagedestroyer_280_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_349_4_end: ;
}
void Frames::event_func_636()
{
    // event 353_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) == (0))) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_353_4_end;
        FrameObject * single_instance_353_4_0; single_instance_353_4_0 = pick_random(spikeshooter_147_instances);
        if (single_instance_353_4_0 == NULL) goto event_353_4_end;
        ((Active*)((Active*)single_instance_353_4_0))->destroy();
        FrameObject * single_instance_353_4_1; single_instance_353_4_1 = NULL;
        // select single: true false false
        {
            FrameObject * new_obj;
            new_obj = add_object(create_explosion_130(((Active*)single_instance_353_4_0)->x + 0, ((Active*)single_instance_353_4_0)->y + 0), ((Active*)single_instance_353_4_0)->layer);
            if (single_instance_353_4_1 == NULL)
                single_instance_353_4_1 = new_obj;
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)single_instance_353_4_0)->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)single_instance_353_4_0)->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
    }
    event_353_4_end: ;
}
void Frames::event_func_637()
{
    // event 354_4
    {
        // group: Spike Shooter Test Enemy
        every_354_4_0 += manager.dt;
        if (every_354_4_0 < 3.0) goto event_354_4_end;
        every_354_4_0 -= 3.0;
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_354_4_end: ;
}
void Frames::event_func_638()
{
    // event 355_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_animation(12))) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_355_4_end;
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            ((Active*)*it)->get_movement()->stop(0);
        }
    }
    event_355_4_end: ;
}
void Frames::event_func_639()
{
    // event 356_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->test_animation(0))) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_356_4_end;
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            ((Active*)*it)->get_movement()->start();
        }
    }
    event_356_4_end: ;
}
void Frames::event_func_640()
{
    // event 357_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_357_4_end;
        FrameObject * single_instance_357_4_0; single_instance_357_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_357_4_0 == NULL)
                    single_instance_357_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_357_4_0))->set_direction(24);
    }
    event_357_4_end: ;
}
void Frames::event_func_641()
{
    // event 358_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_358_4_end;
        FrameObject * single_instance_358_4_0; single_instance_358_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_358_4_0 == NULL)
                    single_instance_358_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_358_4_0))->set_direction(8);
    }
    event_358_4_end: ;
}
void Frames::event_func_642()
{
    // event 359_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_359_4_end;
        FrameObject * single_instance_359_4_0; single_instance_359_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_359_4_0 == NULL)
                    single_instance_359_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_359_4_0))->set_direction(16);
    }
    event_359_4_end: ;
}
void Frames::event_func_643()
{
    // event 360_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_360_4_end;
        FrameObject * single_instance_360_4_0; single_instance_360_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_360_4_0 == NULL)
                    single_instance_360_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_360_4_0))->set_direction(0);
    }
    event_360_4_end: ;
}
void Frames::event_func_644()
{
    // event 361_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_361_4_end;
        FrameObject * single_instance_361_4_0; single_instance_361_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_361_4_0 == NULL)
                    single_instance_361_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_361_4_0))->set_direction(12);
    }
    event_361_4_end: ;
}
void Frames::event_func_645()
{
    // event 362_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_362_4_end;
        FrameObject * single_instance_362_4_0; single_instance_362_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_362_4_0 == NULL)
                    single_instance_362_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_362_4_0))->set_direction(4);
    }
    event_362_4_end: ;
}
void Frames::event_func_646()
{
    // event 363_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_363_4_end;
        FrameObject * single_instance_363_4_0; single_instance_363_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_363_4_0 == NULL)
                    single_instance_363_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_363_4_0))->set_direction(20);
    }
    event_363_4_end: ;
}
void Frames::event_func_647()
{
    // event 364_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!spikeshooter_147_instances.has_selection()) goto event_364_4_end;
        FrameObject * single_instance_364_4_0; single_instance_364_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(spikeshooter_147_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_active2_150(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_364_4_0 == NULL)
                    single_instance_364_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_364_4_0))->set_direction(28);
    }
    event_364_4_end: ;
}
void Frames::event_func_648()
{
    // event 365_4
    {
        // group: Spike Shooter Test Enemy
        screen_148_instances.clear_selection();
        if (!check_not_overlap(screen_148_instances, active2_150_instances)) goto event_365_4_end;
        every_365_4_0 += manager.dt;
        if (every_365_4_0 < 1.0) goto event_365_4_end;
        every_365_4_0 -= 1.0;
        active2_150_instances.clear_selection();
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_365_4_end: ;
}
void Frames::event_func_649()
{
    // event 368_4
    {
        // group: Spike Shooter Test Enemy
        spikeshooter_147_instances.clear_selection();
        if (!check_not_overlap(spikeshooter_147_instances, screen_148_instances)) goto event_368_4_end;
        every_368_4_0 += manager.dt;
        if (every_368_4_0 < 0.5) goto event_368_4_end;
        every_368_4_0 -= 0.5;
        for (ObjectIterator it(spikeshooter_147_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_368_4_end: ;
}
void Frames::event_func_650()
{
    // event 370_4
    {
        // group: Floaters
        floaterspawner_166_instances.clear_selection();
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) >= (200))) { it.deselect(); continue; }
        }
        if (!floaterspawner_166_instances.has_selection()) goto event_370_4_end;
        screen_148_instances.clear_selection();
        if (!check_overlap(floaterspawner_166_instances, screen_148_instances)) goto event_370_4_end;
        if (not_always_370_4_0 > loop_count) {
            not_always_370_4_0 = loop_count + 2;
            goto event_370_4_end;
        }
        not_always_370_4_0 = loop_count + 2;
        FrameObject * single_instance_370_4_1; single_instance_370_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(floaterspawner_166_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyfloater_165(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_370_4_1 == NULL)
                    single_instance_370_4_1 = new_obj;
            }
        }
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_370_4_end: ;
}
void Frames::event_func_651()
{
    // event 371_4
    {
        // group: Floaters
        enemyfloater_165_instances.clear_selection();
        for (ObjectIterator it(enemyfloater_165_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
    }
    event_371_4_end: ;
}
void Frames::event_func_652()
{
    // event 373_4
    {
        // group: Floaters
        enemyfloater_165_instances.clear_selection();
        for (ObjectIterator it(enemyfloater_165_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemyfloater_165_instances.has_selection()) goto event_373_4_end;
        FrameObject * single_instance_373_4_0; single_instance_373_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemyfloater_165_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + 0), parent->layer);
                if (single_instance_373_4_0 == NULL)
                    single_instance_373_4_0 = new_obj;
            }
        }
        for (ObjectIterator it(enemyfloater_165_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemyfloater_165_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemyfloater_165_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        {
            loop_debris_running = true;
            int times = int(3);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 14); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 14); // 'camera shaker'
    }
    event_373_4_end: ;
}
void Frames::event_func_653()
{
    // event 374_4
    {
        // group: Floaters
        active2_150_instances.clear_selection();
        if (!check_not_overlap(active2_150_instances, screen_148_instances)) goto event_374_4_end;
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(3, 1); // 'Active 2'
        }
    }
    event_374_4_end: ;
}
void Frames::event_func_654()
{
    // event 375_4
    {
        // group: Floaters
        active2_150_instances.clear_selection();
        screen_148_instances.clear_selection();
        if (!check_overlap(active2_150_instances, screen_148_instances)) goto event_375_4_end;
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 0); // 'Active 2'
        }
    }
    event_375_4_end: ;
}
void Frames::event_func_655()
{
    // event 376_4
    {
        // group: Floaters
        active2_150_instances.clear_selection();
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) == (60))) { it.deselect(); continue; }
        }
        if (!active2_150_instances.has_selection()) goto event_376_4_end;
        for (ObjectIterator it(active2_150_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_376_4_end: ;
}
void Frames::event_func_656()
{
    // event 377_4
    {
        // group: Floaters
        enemyfloater_165_instances.clear_selection();
        hurtbox_174_instances.clear_selection();
        if (!check_overlap(enemyfloater_165_instances, hurtbox_174_instances)) goto event_377_4_end;
        FrameObject * single_instance_377_4_0; single_instance_377_4_0 = pick_random(enemyfloater_165_instances);
        if (single_instance_377_4_0 == NULL) goto event_377_4_end;
        if (!((((Active*)get_instance(player_93_instances))->alterables->values.get(9)) <= (0))) goto event_377_4_end;
        if (not_always_377_4_1 > loop_count) {
            not_always_377_4_1 = loop_count + 2;
            goto event_377_4_end;
        }
        not_always_377_4_1 = loop_count + 2;
        global_values->sub(0, ((Active*)single_instance_377_4_0)->alterables->values.get(0));
        {
            loop_healthupdate_running = true;
            int times = int(2);
            loop_healthupdate_index = 0;
            while (loop_healthupdate_index < times) {
                loop_healthupdate_4();
                if (!loop_healthupdate_running) break;
                loop_healthupdate_index++;
            }
        }
        ((Active*)get_instance(player_93_instances))->alterables->values.set(7, 34); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(4, 0); // 'Player'
        ((Active*)get_instance(player_93_instances))->alterables->values.set(9, 75); // 'Player'
    }
    event_377_4_end: ;
}
void Frames::event_func_657()
{
    // event 378_4
    {
        // group: Floaters
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.add(7, 1); // 'FrameDataStore'
        floaterspawner_166_instances.clear_selection();
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(1, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(7)); // 'Floater-Spawner'
        }
        enemyspawnerhoppy_279_instances.clear_selection();
        for (ObjectIterator it(enemyspawnerhoppy_279_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, ((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(7)); // 'enemy-spawner-hoppy'
        }
    }
    event_378_4_end: ;
}
void Frames::event_func_658()
{
    // event 379_4
    {
        // group: Floaters
        if (!((((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(7)) >= (200))) goto event_379_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(7, 0); // 'FrameDataStore'
    }
    event_379_4_end: ;
}
void Frames::event_func_659()
{
    // event 380_4
    {
        // group: Floaters
        objjunkblock_266_instances.clear_selection();
        floaterspawner_166_instances.clear_selection();
        if (!check_overlap(objjunkblock_266_instances, floaterspawner_166_instances)) goto event_380_4_end;
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 1); // 'Floater-Spawner'
            ((Active*)*it)->alterables->values.set(1, 0); // 'Floater-Spawner'
        }
    }
    event_380_4_end: ;
}
void Frames::event_func_660()
{
    // event 381_4
    {
        // group: Floaters
        floaterspawner_166_instances.clear_selection();
        if (!check_not_overlap(floaterspawner_166_instances, screen_148_instances)) goto event_381_4_end;
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 1); // 'Floater-Spawner'
            ((Active*)*it)->alterables->values.set(1, 0); // 'Floater-Spawner'
        }
    }
    event_381_4_end: ;
}
void Frames::event_func_661()
{
    // event 382_4
    {
        // group: Floaters
        objjunkblock_266_instances.clear_selection();
        enemyspawnerhoppy_279_instances.clear_selection();
        if (!check_overlap(objjunkblock_266_instances, enemyspawnerhoppy_279_instances)) goto event_382_4_end;
        for (ObjectIterator it(enemyspawnerhoppy_279_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-spawner-hoppy'
        }
    }
    event_382_4_end: ;
}
void Frames::event_func_662()
{
    // event 383_4
    {
        // group: Floaters
        enemyspawnerhoppy_279_instances.clear_selection();
        if (!check_not_overlap(enemyspawnerhoppy_279_instances, screen_148_instances)) goto event_383_4_end;
        for (ObjectIterator it(enemyspawnerhoppy_279_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-spawner-hoppy'
        }
    }
    event_383_4_end: ;
}
void Frames::event_func_663()
{
    // event 384_4
    {
        // group: Floaters
        floaterspawner_166_instances.clear_selection();
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->get_x()) < (((Active*)get_instance(player_93_instances))->get_x()+33))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_x()) > (((Active*)get_instance(player_93_instances))->get_x()-33))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) < (((Active*)get_instance(player_93_instances))->get_y()+66))) { it.deselect(); continue; }
            if (!((((Active*)(*it))->get_y()) > (((Active*)get_instance(player_93_instances))->get_y()-33))) { it.deselect(); continue; }
        }
        if (!floaterspawner_166_instances.has_selection()) goto event_384_4_end;
        for (ObjectIterator it(floaterspawner_166_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(0, 1); // 'Floater-Spawner'
            ((Active*)*it)->alterables->values.set(1, 0); // 'Floater-Spawner'
        }
    }
    event_384_4_end: ;
}
void Frames::event_func_664()
{
    // event 386_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        enemyup_162_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyup_162_instances)) goto event_386_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            if (((Active*)(*it))->test_directions(256)) { it.deselect(); continue; }
        }
        if (!enemypath_155_instances.has_selection()) goto event_386_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(4, 1); // 'enemy-path'
        }
    }
    event_386_4_end: ;
}
void Frames::event_func_665()
{
    // event 387_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        enemydown_160_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemydown_160_instances)) goto event_387_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(5, 1); // 'enemy-path'
        }
    }
    event_387_4_end: ;
}
void Frames::event_func_666()
{
    // event 388_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        enemyleft_161_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyleft_161_instances)) goto event_388_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(6, 1); // 'enemy-path'
        }
    }
    event_388_4_end: ;
}
void Frames::event_func_667()
{
    // event 389_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        enemyright_159_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyright_159_instances)) goto event_389_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(7, 1); // 'enemy-path'
        }
    }
    event_389_4_end: ;
}
void Frames::event_func_668()
{
    // event 390_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) >= (16))) { it.deselect(); continue; }
        }
        if (!enemypath_155_instances.has_selection()) goto event_390_4_end;
        enemyup_162_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyup_162_instances)) goto event_390_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(8);
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(6, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-path'
        }
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            FrameObject * parent = ((Active*)get_single(enemyup_162_instances, it.current_index));
            if (parent == NULL) goto pos_end_390_4_0;
            ((Active*)*it)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_390_4_0: ;
        }
    }
    event_390_4_end: ;
}
void Frames::event_func_669()
{
    // event 391_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(5)) >= (16))) { it.deselect(); continue; }
        }
        if (!enemypath_155_instances.has_selection()) goto event_391_4_end;
        enemydown_160_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemydown_160_instances)) goto event_391_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(24);
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(6, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-path'
        }
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            FrameObject * parent = ((Active*)get_single(enemydown_160_instances, it.current_index));
            if (parent == NULL) goto pos_end_391_4_0;
            ((Active*)*it)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_391_4_0: ;
        }
    }
    event_391_4_end: ;
}
void Frames::event_func_670()
{
    // event 392_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(6)) >= (16))) { it.deselect(); continue; }
        }
        if (!enemypath_155_instances.has_selection()) goto event_392_4_end;
        enemyleft_161_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyleft_161_instances)) goto event_392_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(16);
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(6, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-path'
        }
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            FrameObject * parent = ((Active*)get_single(enemyleft_161_instances, it.current_index));
            if (parent == NULL) goto pos_end_392_4_0;
            ((Active*)*it)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_392_4_0: ;
        }
    }
    event_392_4_end: ;
}
void Frames::event_func_671()
{
    // event 393_4
    {
        // group: Enemy Movers
        enemypath_155_instances.clear_selection();
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(7)) >= (16))) { it.deselect(); continue; }
        }
        if (!enemypath_155_instances.has_selection()) goto event_393_4_end;
        enemyright_159_instances.clear_selection();
        if (!check_overlap(enemypath_155_instances, enemyright_159_instances)) goto event_393_4_end;
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(0);
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(5, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(6, 0); // 'enemy-path'
            ((Active*)*it)->alterables->values.set(7, 0); // 'enemy-path'
        }
        for (ObjectIterator it(enemypath_155_instances); !it.end(); ++it) {
            FrameObject * parent = ((Active*)get_single(enemyright_159_instances, it.current_index));
            if (parent == NULL) goto pos_end_393_4_0;
            ((Active*)*it)->set_global_position(parent->get_x() + 0, parent->get_y() + 0);
            pos_end_393_4_0: ;
        }
    }
    event_393_4_end: ;
}
void Frames::event_func_672()
{
    // event 395_4
    {
        // group: Shooter
        active_1_instances.clear_selection();
        for (ObjectIterator it(active_1_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
    }
    event_395_4_end: ;
}
void Frames::event_func_673()
{
    // event 396_4
    {
        // group: Shooter
        every_396_4_0 += manager.dt;
        if (every_396_4_0 < 1.76) goto event_396_4_end;
        every_396_4_0 -= 1.76;
        active_1_instances.clear_selection();
        screen_148_instances.clear_selection();
        if (!check_overlap(active_1_instances, screen_148_instances)) goto event_396_4_end;
        FrameObject * single_instance_396_4_1; single_instance_396_4_1 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(active_1_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyflashbullet_168(parent->get_action_x() - parent->layer->off_x + 0, parent->get_action_y() - parent->layer->off_y + 0), parent->layer);
                if (single_instance_396_4_1 == NULL)
                    single_instance_396_4_1 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_396_4_1))->set_direction(((Active*)get_single(active_1_instances, default_active_instance))->get_direction());
        ((Active*)((Active*)single_instance_396_4_1))->get_movement()->set_speed(37);
        ((Active*)((Active*)single_instance_396_4_1))->set_direction(get_direction_int(((Active*)single_instance_396_4_1)->x, ((Active*)single_instance_396_4_1)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
    }
    event_396_4_end: ;
}
void Frames::event_func_674()
{
    // event 397_4
    {
        // group: Shooter
        enemyflashbullet_168_instances.clear_selection();
        active_1_instances.clear_selection();
        if (!check_overlap(enemyflashbullet_168_instances, active_1_instances)) goto event_397_4_end;
        for (ObjectIterator it(enemyflashbullet_168_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(((Active*)get_single(active_1_instances, it.current_index, default_active_instance))->get_direction());
            ((Active*)*it)->get_movement()->set_speed(37);
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
    }
    event_397_4_end: ;
}
void Frames::event_func_675()
{
    // event 403_4
    {
        // group: Enemies
        spikesleft_170_instances.clear_selection();
        for (ObjectIterator it(spikesleft_170_instances); !it.end(); ++it) {
            ((Active*)*it)->move_front();
        }
        spikesbottom_171_instances.clear_selection();
        for (ObjectIterator it(spikesbottom_171_instances); !it.end(); ++it) {
            ((Active*)*it)->move_front();
        }
        spikestop_172_instances.clear_selection();
        for (ObjectIterator it(spikestop_172_instances); !it.end(); ++it) {
            ((Active*)*it)->move_front();
        }
        spikesright_173_instances.clear_selection();
        for (ObjectIterator it(spikesright_173_instances); !it.end(); ++it) {
            ((Active*)*it)->move_front();
        }
    }
    event_403_4_end: ;
}
void Frames::event_func_676()
{
    // event 406_4
    {
        // group: Atom Bomb
        enemyatom_176_instances.clear_selection();
        for (ObjectIterator it(enemyatom_176_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(4, 0.01); // 'enemy-atom'
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-atom'
        }
        spawneratom_175_instances.clear_selection();
        for (ObjectIterator it(spawneratom_175_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(3, 1); // 'SpawnerAtom'
        }
    }
    event_406_4_end: ;
}
void Frames::event_func_677()
{
    // event 407_4
    {
        // group: Atom Bomb
        enemyatom_176_instances.clear_selection();
        for (ObjectIterator it(enemyatom_176_instances); !it.end(); ++it) {
            ((Active*)*it)->set_y(((Active*)*it)->alterables->values.get(7)+(((Active*)*it)->alterables->values.get(0)*sin_deg((((Active*)*it)->alterables->values.get(1)*((Active*)*it)->alterables->values.get(2))-(((Active*)*it)->alterables->values.get(3)*((Active*)*it)->alterables->values.get(4)))));
        }
    }
    event_407_4_end: ;
}
void Frames::event_func_678()
{
    // event 408_4
    {
        // group: Atom Bomb
        enemyatom_176_instances.clear_selection();
        for (ObjectIterator it(enemyatom_176_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->get_x()-1);
        }
    }
    event_408_4_end: ;
}
void Frames::event_func_679()
{
    // event 410_4
    {
        // group: Atom Bomb
        bigexplosion_177_instances.clear_selection();
        for (ObjectIterator it(bigexplosion_177_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 0)) { it.deselect(); continue; }
        }
        if (!bigexplosion_177_instances.has_selection()) goto event_410_4_end;
        for (ObjectIterator it(bigexplosion_177_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
    }
    event_410_4_end: ;
}
void Frames::event_func_680()
{
    // event 414_4
    {
        // group: Chomper
        screen_148_instances.clear_selection();
        enemychomper_184_instances.clear_selection();
        if (!check_overlap(screen_148_instances, enemychomper_184_instances)) goto event_414_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.add(4, 1); // 'enemy-chomper'
        }
    }
    event_414_4_end: ;
}
void Frames::event_func_681()
{
    // event 415_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(4)) >= (100))) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(12)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(13)) { it.deselect(); continue; }
            if (((Active*)(*it))->test_animation(6)) { it.deselect(); continue; }
        }
        if (!enemychomper_184_instances.has_selection()) goto event_415_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(12);
        }
    }
    event_415_4_end: ;
}
void Frames::event_func_682()
{
    // event 416_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!enemychomper_184_instances.has_selection()) goto event_416_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) < (((Active*)get_single(enemychomper_184_instances, default_active_instance))->get_x()))) goto event_416_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(6);
            ((Active*)*it)->alterables->values.set(2, ((Active*)get_instance(player_93_instances))->get_x()-((Active*)*it)->get_x()); // 'enemy-chomper'
            ((Active*)*it)->alterables->values.set(3, ((Active*)get_instance(player_93_instances))->get_y()-((Active*)*it)->get_y()); // 'enemy-chomper'
        }
        FrameObject * single_instance_416_4_0; single_instance_416_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemychomper_184_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyzapball_185(parent->x + 0, parent->y + -17), parent->layer);
                if (single_instance_416_4_0 == NULL)
                    single_instance_416_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_416_4_0))->alterables->values.set(0, -4); // 'enemy-zapball'
        ((Active*)((Active*)single_instance_416_4_0))->alterables->values.set(1, -1*(((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(3)/MathHelper()/(((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(2)/MathHelper()/4.0))-0.5*-0.125*(((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(2)/MathHelper()/4.0)); // 'enemy-zapball'
    }
    event_416_4_end: ;
}
void Frames::event_func_683()
{
    // event 417_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 12)) { it.deselect(); continue; }
        }
        if (!enemychomper_184_instances.has_selection()) goto event_417_4_end;
        if (!((((Active*)get_instance(player_93_instances))->get_x()) > (((Active*)get_single(enemychomper_184_instances, default_active_instance))->get_x()))) goto event_417_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->force_animation(6);
            ((Active*)*it)->alterables->values.set(2, ((Active*)get_instance(player_93_instances))->get_x()-((Active*)*it)->get_x()); // 'enemy-chomper'
            ((Active*)*it)->alterables->values.set(3, ((Active*)get_instance(player_93_instances))->get_y()-((Active*)*it)->get_y()); // 'enemy-chomper'
        }
        FrameObject * single_instance_417_4_0; single_instance_417_4_0 = NULL;
        // select single: true false false
        for (ObjectIterator p_it(enemychomper_184_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_enemyzapball_185(parent->x + 0, parent->y + -17), parent->layer);
                if (single_instance_417_4_0 == NULL)
                    single_instance_417_4_0 = new_obj;
            }
        }
        ((Active*)((Active*)single_instance_417_4_0))->alterables->values.set(0, 4); // 'enemy-zapball'
        ((Active*)((Active*)single_instance_417_4_0))->alterables->values.set(1, (((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(3)/MathHelper()/(((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(2)/MathHelper()/4.0))-0.5*0.125*(((Active*)get_single(enemychomper_184_instances, default_active_instance))->alterables->values.get(2)/MathHelper()/4.0)); // 'enemy-zapball'
    }
    event_417_4_end: ;
}
void Frames::event_func_684()
{
    // event 418_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            if (!(((Active*)(*it))->animation_finished == 6)) { it.deselect(); continue; }
        }
        if (!enemychomper_184_instances.has_selection()) goto event_418_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-chomper'
            ((Active*)*it)->force_animation(0);
        }
    }
    event_418_4_end: ;
}
void Frames::event_func_685()
{
    // event 419_4
    {
        // group: Chomper
        every_419_4_0 += manager.dt;
        if (every_419_4_0 < 0.1) goto event_419_4_end;
        every_419_4_0 -= 0.1;
        enemyzapball_185_instances.clear_selection();
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(1, -1*((Active*)*it)->alterables->values.get(2)); // 'enemy-zapball'
        }
    }
    event_419_4_end: ;
}
void Frames::event_func_686()
{
    // event 421_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) <= (0))) { it.deselect(); continue; }
        }
        if (!enemychomper_184_instances.has_selection()) goto event_421_4_end;
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(0, ((Active*)get_single(enemychomper_184_instances, default_active_instance))->get_x()); // 'FrameDataStore'
        ((Active*)get_instance(framedatastore_183_instances))->alterables->values.set(1, ((Active*)get_single(enemychomper_184_instances, default_active_instance))->get_y()); // 'FrameDataStore'
        media.play_id(SOUND_EXPLOSION_6, 26-1);
        media.set_sample_volume(SOUND_EXPLOSION_6, global_values->get(12)*0.25);
        explosion_130_instances.clear_selection();
        for (ObjectIterator it(explosion_130_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(0));
            ((Active*)*it)->set_y(((Active*)get_instance(framedatastore_183_instances))->alterables->values.get(1)-14);
        }
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(2, 20); // 'camera shaker'
        ((Active*)get_instance(camerashaker_247_instances))->alterables->values.set(3, 20); // 'camera shaker'
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->destroy();
        }
        // select single: false false true
        for (ObjectIterator p_it(enemychomper_184_instances); !p_it.end(); ++p_it) {
            FrameObject * parent = ((Active*)*p_it);
            {
                FrameObject * new_obj;
                new_obj = add_object(create_explosion_130(parent->x + 0, parent->y + -14), parent->layer);
                explosion_130_instances.add_back();
            }
        }
        {
            loop_debris_running = true;
            int times = int(7);
            loop_debris_index = 0;
            while (loop_debris_index < times) {
                loop_debris_4();
                if (!loop_debris_running) break;
                loop_debris_index++;
            }
        }
    }
    event_421_4_end: ;
}
void Frames::event_func_687()
{
    // event 424_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
        }
        enemyzapball_185_instances.clear_selection();
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)*it)->get_x()+((Active*)*it)->alterables->values.get(0));
            ((Active*)*it)->set_y(((Active*)*it)->get_y()+((Active*)*it)->alterables->values.get(1));
        }
    }
    event_424_4_end: ;
}
void Frames::event_func_688()
{
    // event 425_4
    {
        // group: Chomper
        enemyzapball_185_instances.clear_selection();
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(1)) > (6))) { it.deselect(); continue; }
        }
        if (!enemyzapball_185_instances.has_selection()) goto event_425_4_end;
        for (ObjectIterator it(enemyzapball_185_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(1, 6); // 'enemy-zapball'
        }
    }
    event_425_4_end: ;
}
void Frames::event_func_689()
{
    // event 427_4
    {
        // group: Chomper
        every_427_4_0 += manager.dt;
        if (every_427_4_0 < 0.01) goto event_427_4_end;
        every_427_4_0 -= 0.01;
        spawnerenemychomper_187_instances.clear_selection();
        for (ObjectIterator it(spawnerenemychomper_187_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) > (0))) { it.deselect(); continue; }
        }
        if (!spawnerenemychomper_187_instances.has_selection()) goto event_427_4_end;
        for (ObjectIterator it(spawnerenemychomper_187_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(3, 1); // 'spawner-enemy-chomper'
        }
    }
    event_427_4_end: ;
}
void Frames::event_func_690()
{
    // event 428_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        if (!check_overlap(enemychomper_184_instances, enemychomper_184_instances)) goto event_428_4_end;
        FrameObject * single_instance_428_4_0; single_instance_428_4_0 = pick_random(enemychomper_184_instances);
        if (single_instance_428_4_0 == NULL) goto event_428_4_end;
        ((Active*)((Active*)single_instance_428_4_0))->destroy();
    }
    event_428_4_end: ;
}
void Frames::event_func_691()
{
    // event 429_4
    {
        // group: Chomper
        enemychomper_184_instances.clear_selection();
        if (!check_overlap(enemychomper_184_instances, enemychomper_184_instances)) goto event_429_4_end;
        for (ObjectIterator it(enemychomper_184_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(4, 0); // 'enemy-chomper'
        }
    }
    event_429_4_end: ;
}
void Frames::event_func_692()
{
    // event 431_4
    {
        // group: BrokenBrain
        enemybrokenrobot_192_instances.clear_selection();
        for (ObjectIterator it(enemybrokenrobot_192_instances); !it.end(); ++it) {
            ((Active*)*it)->set_direction(get_direction_int(((Active*)*it)->x, ((Active*)*it)->y, ((Active*)get_instance(player_93_instances))->x + 0, ((Active*)get_instance(player_93_instances))->y + 0));
            ((Active*)*it)->alterables->values.set(2, ((Active*)*it)->get_x()); // 'enemy-brokenrobot'
            ((Active*)*it)->alterables->values.set(3, ((Active*)*it)->get_y()); // 'enemy-brokenrobot'
        }
        bullet_121_instances.clear_selection();
        for (ObjectIterator it(bullet_121_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.set(6, ((Active*)*it)->get_x()); // 'Bullet'
            ((Active*)*it)->alterables->values.set(7, ((Active*)*it)->get_y()); // 'Bullet'
        }
    }
    event_431_4_end: ;
}
void Frames::event_func_693()
{
    // event 433_4
    {
        // group: BrokenBrain
        every_433_4_0 += manager.dt;
        if (every_433_4_0 < 0.01) goto event_433_4_end;
        every_433_4_0 -= 0.01;
        spawnerbrokenrobot_193_instances.clear_selection();
        for (ObjectIterator it(spawnerbrokenrobot_193_instances); !it.end(); ++it) {
            if (!((((Active*)(*it))->alterables->values.get(3)) > (0))) { it.deselect(); continue; }
        }
        if (!spawnerbrokenrobot_193_instances.has_selection()) goto event_433_4_end;
        for (ObjectIterator it(spawnerbrokenrobot_193_instances); !it.end(); ++it) {
            ((Active*)*it)->alterables->values.sub(3, 1); // 'spawnerbrokenrobot'
        }
    }
    event_433_4_end: ;
}
void Frames::event_func_694()
{
    // event 434_4
    {
        // group: BrokenBrain
        enemybrokenrobot_192_instances.clear_selection();
        enemybrokenrobottop_194_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobottop_194_instances)) goto event_434_4_end;
        for (ObjectIterator it(enemybrokenrobottop_194_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)get_single(enemybrokenrobot_192_instances, it.current_index, default_active_instance))->get_x());
            ((Active*)*it)->set_y(((Active*)get_single(enemybrokenrobot_192_instances, it.current_index, default_active_instance))->get_y());
        }
    }
    event_434_4_end: ;
}
void Frames::event_func_695()
{
    // event 435_4
    {
        // group: BrokenBrain
        enemybrokenrobot_192_instances.clear_selection();
        enemybrokenrobotbottom_195_instances.clear_selection();
        if (!check_overlap(enemybrokenrobot_192_instances, enemybrokenrobotbottom_195_instances)) goto event_435_4_end;
        for (ObjectIterator it(enemybrokenrobotbottom_195_instances); !it.end(); ++it) {
            ((Active*)*it)->set_x(((Active*)get_single(enemybrokenrobot_192_instances, it.current_index, default_active_instance))->get_x());
            ((Active*)*it)->set_y(((Active*)get_single(enemybrokenrobot_192_instances, it.current_index, default_active_instance))->get_y());
        }
    }
    event_435_4_end: ;
}
